<?php
/**
 * Eve-Online API Trawler
 *
 */
require_once('config.php');
require_once('includes/vbulletin.php');
require_once('includes/db.php');
require_once('includes/class.functions.php');
require_once('includes/class.cachetimers.php');
require_once('includes/class.api.skilltree.php');

$qry = new DBQuery();

// prepare page
$title = "EVE API Trawler :: Index";
require_once('includes/css.php');
require_once('includes/header.php');
$footer = "</body></html>";

if ($isvbAdmin)
{
	// update skills table from API (needs to be there on first run)
	$skilltree = new SkillTreeAPI();
	$streeresult = $skilltree->fetch();
	
	// list all skills and provide a box to enter required skill level
	if ($_POST["saveskills"])
	{
		$saveskills = $_POST['skill'];
		
		if (isset($saveskills))
		{
			// update each required skill level
			foreach($saveskills as $skillID=>$skillReqLevel)
			{
				updateSkillTable($skillID, $skillReqLevel);
			}
		}
	}
	$skills = getAllSkills();
	
	if (isset($skills))
	{
		// Create Table for Player details to go in
		$page .= '<form method="post" action="admin.php" name="reqskills">';
		$page .= '<br><table align="center" border="1" width="60%" cellpadding="2"><tr><td align="center"><b>Skill</b></td><td align="center"><b>Skill Group</b></td><td align="center"><b>Required Level</b></td></tr>';
		foreach( $skills as $skill)
		{
			//$page .= $skill['typeID'] . " - " . $skill['typeName'] . " (" . $skill['groupName'] . ") - " . $skill['requiredLevel'] . "<br/>";
			$page .= '<tr><td align="center">' .  $skill['typeName'] . '</td>'; 
			$page .= '<td>' . $skill['groupName'] . '</td>';
			$page .= '<td><input type="text" name="skill[' . $skill['typeID'] . ']" maxlength="1" value="' . $skill['requiredLevel'] 
					  . '"></td></tr>';
			
		}
		$page .= '</table>';
		$page .= '<div align="center"><input type="submit" value="Save Skills" name="saveskills"></div>';
		$page .= '</form>';
	} 
} else {
	echo "you are not logged into forum";
}
	
$page .= $footer;
print $page;

function getAllSkills()
{
	$qry = new DBQuery();
	
	$sql = "SELECT s.typeID, s.groupID, s.typeName, g.groupName, s.requiredLevel
			FROM eve_skills s, eve_skillgroups g
			WHERE s.groupID = g.groupID
			ORDER BY g.groupName, s.typeName";
	$qry->execute($sql);
	
	while($row = $qry->getRow())
	{
		$allskills[] = $row;
	}
	
	return $allskills;
}

function updateSkillTable($skillID, $skillReqLevel)
{
	$qry = new DBQuery();
	
	// stupidity checks
	if ( ($skillReqLevel > 5) || ($skillReqLevel < 0) )
		$skillReqLevel = 0;
		
	$sql = "UPDATE eve_skills
			SET requiredLevel = '" . (integer)$skillReqLevel . "'
			WHERE typeID = '" . (integer)$skillID . "'";
	$qry->execute($sql);
}
?>