<?php

/**
 * Eve-Online API Trawler
 *
 */
 
class Analysis
{
	function Analysis($playerid = 0)
    {
		$this->playerID_ = $playerid;
		
		
		$this->accountArray_ = array();
    }
	
	function getNumAccounts()
    {
        return $this->numAccounts_;
    }
	
	function getSkill($typeID)
    {
		$qry = new DBQuery();
		
        $sql = "SELECT s.typeID, s.groupID, s.typeName, g.groupName 
						FROM eve_skills s, eve_skillgroups g
						WHERE s.groupID = g.groupID and s.typeID = " . $typeID;

        $qry->execute($sql);
		
		if ($qry->recordCount() != 0)
        {
			$row = $qry->getRow();
			
			return $row;
		}
			
		return false;
    }
	
	function getCharSkills($charID)
	{
		$qry = new DBQuery();
		
        $sql = "SELECT * 
				FROM skills s, eve_skills es, eve_skillgroups g
				WHERE es.groupID = g.groupID
				AND s.typeID = es.typeid
				AND s.characterID = " . $charID . "
				ORDER BY g.groupName, es.typeName ASC"; 
	
		$qry->execute($sql);
		
		while($skill = $qry->getRow())
		{
			$skillsarray[] = $skill;
		}
			
		return $skillsarray;
	}
	
	function getPlayerAccounts()
    {
		$qry = new DBQuery();
		
		if ($this->playerID_ == 0)
			return false;
			
		unset($this->accountArray_);
		
        $sql = "SELECT * 
				FROM `accounts` 
				WHERE `playerID` = " . $this->playerID_ . 
				" ORDER BY `userID` ASC";
        $qry->execute($sql);
		
		$this->numAccounts_ = $qry->recordCount();
		
		while($account_ = $qry->getRow())
		{
			$array['userID'] = $account_['userID'];
			$array['apiKey'] = $account_['apiKey'];
			$array['created'] = $account_['created'];
			$array['lastupdated'] = $account_['lastupdated'];
			
			// attach characters to the array object
			$array['characters'] = $this->getCharacters($account_['userID']);
			$accountArray[] = $array;
			unset($array);
		}
		$this->accountArray_ = $accountArray;
		
		return $this->accountArray_;
    }
	
	function getCharacters($userID = 0)
    {
		$qry = new DBQuery();
		
		if ($userID == 0)
			return false;
		
		$sql = "SELECT * 
				FROM `characters` 
				WHERE `userID` = " . $userID . 
				" ORDER BY `characterID` DESC";
        $qry->execute($sql);	
		
		$charArray['numChars'] = $qry->recordCount();
		
		while($character = $qry->getRow())
		{
			$array['characterID'] = $character['characterID'];
			$array['name'] = $character['name'];
			$array['race'] = $character['race'];
			$array['bloodLine'] = $character['bloodLine'];
			$array['gender'] = $character['gender'];
			$array['corporationName'] = $character['corporationName'];
			$array['corporationID'] = $character['corporationID'];
			$array['cloneName'] = $character['cloneName'];
			$array['cloneSkillPoints'] = $character['cloneSkillPoints'];
			$array['balance'] = $character['balance'];
			$array['intelligence'] = $character['intelligence'];
			$array['memory'] = $character['memory'];
			$array['charisma'] = $character['charisma'];
			$array['perception'] = $character['perception'];
			$array['willpower'] = $character['willpower'];
			$array['slot1'] = $character['slot1'];
			$array['slot2'] = $character['slot2'];
			$array['slot3'] = $character['slot3'];
			$array['slot4'] = $character['slot4'];
			$array['slot5'] = $character['slot5'];
			$array['director'] = $character['director'];
			$array['creationDate'] = $character['creationDate'];
			$array['lastupdated'] = $character['lastupdated'];
			
			$charArray['details'][] = $array;
			unset($array);
		}
		
		return $charArray;
	}
	
	function getAllianceName( $corpID )
	{
		$qry = new DBQuery();
		
		$qry->execute("select * from eve_alliances
		               where corporationID = " . $corpID );
		
		if ($qry->recordCount() != 0)
		{
			// match found, this corp is in an alliance
			$row = $qry->getRow();
			$alliance = $row['name'];
			
			return $alliance;
		} else {
			// No match. Return "none"
			return "None.";
		}
	}
	
	function getAssets($ownerID)
	{
		$qry = new DBQuery();
		
        $sql = "SELECT a.container, a.quantity, a.locationID, i.itemName LocationName, e.itemName, a.flag
				FROM assets a, eve_itemid i, eve_itemid e
				WHERE a.locationID = i.itemID
				AND a.typeID = e.itemID
				AND a.ownerID = " . $ownerID . "
				ORDER BY i.itemName, a.counter ASC"; 
	
		$qry->execute($sql);
		
		while($asset = $qry->getRow())
		{
			$tempasset['flagname'] = $this->getFlag($asset['flag']);
			$tempasset['container'] = $asset['container'];
			$tempasset['quantity'] = $asset['quantity'];
			$tempasset['locationID'] = $asset['locationID'];
			$tempasset['LocationName'] = $asset['LocationName'];
			$tempasset['itemName'] = $asset['itemName'];
			$tempasset['flag'] = $asset['flag'];
			
			$assetsarray[] = $tempasset;
			unset($tempasset);
		}
			
		return $assetsarray;
	}
	
	function getFlag($flag)
	{
		switch ($flag)
		{
			case 0:
				$flagname = ""; // 'none' eg Bookmarks
				break;
			case 4:
				$flagname = ""; //'hangar' 
				break;
			case 5:
				$flagname = "cargo";
				break;
			case 11:
			case 12:
			case 13:
			case 14:
			case 15:
			case 16:
			case 17:
			case 18:
				$flagname = "low slot";
				break;
			case 19:
			case 20:
			case 21:
			case 22:
			case 23:
			case 24:
			case 25:
			case 26:
				$flagname = "med slot";
				break;
			case 27:
			case 28:
			case 29:
			case 30:
			case 31:
			case 32:
			case 33:
			case 34:
				$flagname = "high slot";
				break;
			case 62:
				$flagname = "deliveries / returns";
				break;
			case 63:
				$flagname = "locked";
				break;
			case 64:
				$flagname = "unlocked";
				break;
			case 70:
			case 71:
			case 72:
			case 73:
			case 74:
			case 75:
			case 76:
			case 77:
			case 78:
			case 79:
			case 80:
			case 81:
			case 82:
			case 83:
			case 84:
			case 85:
				$flagname = "office slot " . ($flag - 69);
				break;
			case 87:
				$flagname = "drone bay";
				break;
			case 90:
				$flagname = "ship hangar";
				break;
			case 91:
				$flagname = "<b>pilot offline</b>";
				break;
			case 92:
			case 93:
			case 94:
			case 95:
			case 96:
			case 97:
			case 98:
			case 99:
				$flagname = "rig slot";
				break;
			case 122:
				$flagname = "secondary storage";
				break;
			case 125:
			case 126:
			case 127:
			case 128:
			case 129:
			case 130:
			case 131:
			case 132:
				$flagname = "sub system";
				break;
			default: // will in future output new flags as the id number so this function can be altered as needed
				$flagname = $flag;
		}
		
		return $flagname;
	}
	
	function getIndustryJobs($ownerID)
	{
		$qry = new DBQuery();

        $sql = "SELECT a.installTime, i.itemName inputItem, e.itemName outputItem, f.itemName locationName, a.completed,
				a.installedItemLocationID, s.solarSystemName 
				FROM industryjobs a, eve_itemid i, eve_itemid e, eve_itemid f, eve_systems s
				WHERE a.installedItemTypeID = i.itemID
				AND a.outputTypeID = e.itemID
				AND a.installedItemLocationID = f.itemID
				AND a.installedInSolarSystemID = s.solarSystemID
				AND a.ownerID = " . $ownerID . "
				ORDER BY a.installTime DESC";  
	
		$qry->execute($sql);
		
		while($job = $qry->getRow())
		{
			$jobsarray[] = $job;
		}
			
		return $jobsarray;
	}
	
	function getKillLog($ownerID)
	{
		$qry = new DBQuery();
		
        $sql = "SELECT * 
				FROM killlog a, eve_itemid i, eve_systems s
				WHERE a.shipTypeID = i.itemID
				AND a.solarSystemID = s.solarSystemID
				AND a.ownerID = " . $ownerID; 
	
		$qry->execute($sql);
		
		while($kill = $qry->getRow())
		{
			$killsarray[] = $kill;
		}
			
		return $killsarray;
	}
	
	function getMarketOrders($ownerID)
	{
		$qry = new DBQuery();
		
        $sql = "SELECT a.issued, a.bid, a.volEntered, a.price, i.itemName stationName, e.itemName itemName,
		 		f.itemName charName, a.stationID
				FROM marketorders a, eve_itemid i, eve_itemid e, eve_itemid f
				WHERE a.stationID = i.itemID
				AND a.typeID = e.itemID
				AND a.charID = f.itemID
				AND a.ownerID = " . $ownerID . "
				ORDER BY a.issued DESC"; 
	
		$qry->execute($sql);
		
		while($order = $qry->getRow())
		{
			$orderarray[] = $order;
		}
			
		return $orderarray;
	}
	
	function getWalletJournal($ownerID, $key = 1000, $sort = "date")
	{
		$qry = new DBQuery();
		
		if ($sort == "")
			$sort = "date";
			
		if ($sort == "date") {
			$sortstring = "ORDER BY a.date DESC";
		} elseif ($sort == "refTypeID") {
			$sortstring = "ORDER BY r.refTypeName ASC, a.date DESC";
		} elseif ($sort == "ownerName2") {
			$sortstring = "ORDER BY a.ownerName2 ASC, a.date DESC";
		} elseif ($sort == "ownerName1") {
			$sortstring = "ORDER BY a.ownerName1 ASC, a.date DESC";
		}
		
        $sql = "SELECT * 
				FROM walletjournal a, eve_reftypes r
				WHERE a.refTypeID = r.refTypeID
				AND a.ownerID = " . $ownerID . "
				AND a.accountKey = " . $key  .
				" " . $sortstring;

		$qry->execute($sql);
		
		while($entry = $qry->getRow())
		{
			$entryarray[] = $entry;
		}
			
		return $entryarray;
	}
	
	function getWalletTransactions($ownerID, $key = 1000)
	{
		$qry = new DBQuery();
		
        $sql = "SELECT * 
				FROM wallettransactions 
				WHERE ownerID = " . $ownerID . "
				AND accountKey = " .$key . "
				ORDER BY transactionDateTime DESC";

		$qry->execute($sql);
		
		while($transaction = $qry->getRow())
		{
			$transactionarray[] = $transaction;
		}
			
		return $transactionarray;
	}
	
	function getCorpDetails($corpID)
	{
		$qry = new DBQuery();
		
        $sql = "SELECT * 
				FROM corporations
				WHERE corporationID = " . $corpID;
				

		$qry->execute($sql);
		
		$corpdetail = $qry->getRow();
			
		return $corpdetail;
	}
	
	function getWalletNames($corpID)
	{
		$qry = new DBQuery();
		
        $sql = "SELECT * 
				FROM corporations
				WHERE corporationID = " . $corpID;
				
		$qry->execute($sql);
		
		$row = $qry->getRow();
		
		$wallet[1000] = $row['wal1'];
		$wallet[1001] = $row['wal2'];
		$wallet[1002] = $row['wal3'];
		$wallet[1003] = $row['wal4'];
		$wallet[1004] = $row['wal5'];
		$wallet[1005] = $row['wal6'];
		$wallet[1006] = $row['wal7'];
		
		return $wallet;
	}
	
	function getDivisionNames($corpID)
	{
		$qry = new DBQuery();
		
        $sql = "SELECT * 
				FROM corporations
				WHERE corporationID = " . $corpID;
				
		$qry->execute($sql);
		
		$row = $qry->getRow();
		
		$division[0] = $row['div1'];
		$division[1] = $row['div2'];
		$division[2] = $row['div3'];
		$division[3] = $row['div4'];
		$division[4] = $row['div5'];
		$division[5] = $row['div6'];
		$division[6] = $row['div7'];
		
		return $division;
	}
	
	function getAccountBalances($ownerID)
	{
		$qry = new DBQuery();
		
        $sql = "SELECT * 
				FROM accountbalance
				WHERE ownerID = " . $ownerID;
				
		$qry->execute($sql);
		
		while($row = $qry->getRow())
		{
			$balances[$row['accountKey']] = $row['balance'];
		}
		
		return $balances;
	}
	
	function checkStation($stationID)
	{
		// checks to see if $stationID is a conquerable station, if it is it will build a detail string and return it
		$qry = new DBQuery();

        $sql = "SELECT *
				FROM eve_conquerablestations a, eve_systems s, eve_alliances c
				WHERE a.solarSystemID = s.solarSystemID
				AND a.corporationID = c.corporationID
				AND a.stationID = " . $stationID;
				
		$qry->execute($sql);
		
		if ($qry->recordCount() != 0)
		{
			// match found, build return string
			$row = $qry->getRow();
			$alliance = $row['name'];
			$corp = $row['corporationName'];
			$system = $row['solarSystemName'];
			
			$result = "(" . $corp . "; " . $alliance . ", " . $system . ")";
			
			return $result;
		} else {
			// No match. Return empty
			return false;
		}
	}
	
	function getStations($corpID)
	{
		// Get Conquerable stations
		$qry = new DBQuery();

        $sql = "SELECT *
				FROM eve_conquerablestations a, eve_systems s
				WHERE a.solarSystemID = s.solarSystemID
				AND a.corporationID = " . $corpID;
				
		$qry->execute($sql);
		
		while($row = $qry->getRow())
		{
			// match found, build a string and add to return array
			$result[] = $row['stationName'] . " - " . $row['solarSystemName'] . " (sov: ". $row['sovereigntyLevel'] . ")";
		}
		
		return $result;
	}
	
	function getPos($corpID)
	{
		// Get Pos's
		$qry = new DBQuery();
		
        $sql = "SELECT a.stateTimestamp, a.onlineTimestamp, m.itemName moonName, i.itemName posType, s.solarSystemName, a.state
				FROM starbaselist a, eve_systems s, eve_itemid i, eve_itemid m
				WHERE a.locationID = s.solarSystemID
				AND a.typeID = i.itemID
				AND a.moonID = m.itemID
				AND a.corporationID = " . $corpID;
				
		$qry->execute($sql);
		
		while($row = $qry->getRow())
		{
			// match found, build a string and add to return array
			if ($row['moonName'] == "<unresolved ID>")
				$posloc = $row['solarSystemName'] . " - unknown moon";
			else
				$posloc = $row['moonName'];
				
			$posresult = $posloc . " - " . $row['posType'];
			
			if ($row['state'] == 0)
			{
				$posstate = "unanchored";
			} elseif ($row['state'] == 1) {
				$posstate = "Anchored / offline";
			} elseif ($row['state'] == 2) {
				$posstate = "Onlining: " . $row['onlineTimestamp'];
			} elseif ($row['state'] == 3) {
				$posstate = "Reinforced: " . $row['stateTimestamp'];
			} elseif ($row['state'] == 4) {
				$posstate = "Online since: " . $row['onlineTimestamp'];
			}
			$result = $posresult . " - " . $posstate;
	
			$posreturn[] = $result;
		}
		
		return $posreturn;
	}
	
	function getID($ID)
	{
		$qry = new DBQuery();
		
        $sql = "SELECT *
				FROM eve_itemid
				WHERE itemID = " . $ID;
				
		$qry->execute($sql);
		
		$row = $qry->getRow();
		
		return $row['itemName'];
	}
	
	function getMembers($corpID)
	{
		$qry = new DBQuery();
		
        $sql = "SELECT * 
				FROM membertracking
				WHERE corporationID = " . $corpID . "
				ORDER BY name ASC"; 

		$qry->execute($sql);
		
		while($member = $qry->getRow())
		{
			$memberarray[] = $member;
		}
			
		return $memberarray;
	}
	
	function getSystemName($systemID)
	{
		$qry = new DBQuery();
		
        $sql = "SELECT *
				FROM eve_systems
				WHERE solarSystemID = " . $systemID;
				
		$qry->execute($sql);
		
		$row = $qry->getRow();
		
		return $row['solarSystemName'];
	}
	
	function getSkillInTraining($charID)
	{
		$qry = new DBQuery();

        $sql = "SELECT *
				FROM skillintraining s, eve_skills i
				WHERE s.trainingTypeID = i.typeID
				AND s.characterID  = " . $charID;
				
		$qry->execute($sql);
	
		if ($qry->recordCount() != 0)
		{
			$row = $qry->getRow();
			
			$returnstring = $row['typeName'] . " to level " . $row['trainingToLevel'] . " until " . $row['trainingEndTime'];
			return $returnstring;
		} else {
			return "<i>nothing</i>";
		}
	}
	
	function getShareholders($corpID, $isCorp)
	{
		$qry = new DBQuery();

        $sql = "SELECT *
				FROM shareholders
				WHERE corporationID = " . $corpID . " 
				AND isCorp  = " . $isCorp . "
				ORDER BY shares DESC";
				
		$qry->execute($sql);
		
		while($shareholder = $qry->getRow())
		{
			$shareholderarray[] = $shareholder;
		}
			
		return $shareholderarray;
	}
	
	function getStandings($ownerID, $type, $subtype)
	{
		$qry = new DBQuery();

        $sql = "SELECT *
				FROM standings
				WHERE ownerID = " . $ownerID . " 
				AND type  = '" . $type . "' 
				AND subtype  = '" . $subtype . "' 
				ORDER BY toName ASC";
				
		$qry->execute($sql);
		
		while($standing = $qry->getRow())
		{
			// don't add deleted/closed chars/corps (those that have "" for name)
			if ($standing['toName'] != "")
				$standingarray[] = $standing;
		}
			
		return $standingarray;
	}
	
	function getMissingRequiredSkills($CharSkillsArray)
	{
		$qry = new DBQuery();
		
		// get Required skills list
	
		$sql = "SELECT s.typeID, s.groupID, s.typeName, g.groupName, s.requiredLevel
				FROM eve_skills s, eve_skillgroups g
				WHERE s.groupID = g.groupID and s.requiredLevel != 0
				ORDER BY g.groupName, s.typeName";

        $qry->execute($sql);
		
		while($row = $qry->getRow())
		{
			$requiredskills[] = $row;
		}
		
		if ( count($requiredskills) > 0 )
		{
			// loop through the required skills array
			foreach ($requiredskills as $rskill)
			{
				$skillMatch = false;
			
				// loop through chars skills and test if 
				foreach ($CharSkillsArray as $cskill)
				{
					// test for match
					if ( ($rskill['typeID'] == $cskill['typeID']) && ($cskill['level'] >= $rskill['requiredLevel']) )
						$skillMatch = true;
				}
				
				if (!$skillMatch)
					$missingskills[] = $rskill;
			}
		}
		
		return $missingskills;
	}
}

?>