<?php
/**
 * Eve-Online API Trawler
 *
 */

class AccountAPI
{
	function AccountAPI( $userID, $apiKey )
    {
		$this->userID_ = $userID;
		$this->apiKey_ = $apiKey;
		
        $this->apiString_ = array( "userID" => $userID, "apiKey" => $apiKey );
		
		$this->CacheTime_ = ApiCache::get($this->userID_ . "_account");
		$this->CurrentTime_ = ApiCurrent::get($this->userID_ . "_account");
    }
	
	function fetch()
	{
		$baseURL = "http://api.eve-online.com/account/Characters.xml.aspx?";
		
		if ($this->CacheTime_ == "")
    	{
        	$this->CacheTime_ = "2005-01-01 00:00:00"; // fake date to ensure that it runs first time.
    	}
		
		if (is_file(getcwd()."/cache/" . $this->userID_ . "_account.xml"))
			$cacheexists = true;
		else
			$cacheexists = false;
		
		if ((strtotime(gmdate("M d Y H:i:s")) - strtotime($this->CacheTime_) > 0) || !$cacheexists )
        {
            // Load new XML
			$xmlString = @file_get_contents( $baseURL . http_build_query( $this->apiString_ ) );
			
			if(!isset($xmlString) || $xmlString === false)
				$this->error_ = "API Website not responding.";
		} else {
			// load cached XML
			$xmlString = @file_get_contents( "cache/" . $this->userID_  . "_account.xml" );
		}
        $xml = simplexml_load_string( $xmlString );
		
		if( isset($xml->error) )
        {
			$this->error_ = $xml->error;
            $xml = @simplexml_load_file( "cache/" . $this->userID_ . "_account.xml" );
        } else {
            file_put_contents( "cache/" . $this->userID_  . "_account.xml", $xmlString );
        }
        
        if( !$xml->result->rowset->row )
			return false;
		
		// Set Cached Time
		if ($xml->cachedUntil)
		{
			$this->CacheTime_ = $xml->cachedUntil;
			ApiCache::set($this->userID_ . "_account", $this->CacheTime_);
			
			$this->CurrentTime_ = $xml->currentTime;
			ApiCurrent::set($this->userID_ . "_account", $this->CurrentTime_);
		}
		
		foreach( $xml->result->rowset->row as $row )
        {
			$nameArray[] = $row;
		}
		
		return $nameArray;
	}
}
?>