<?php
/**
 * Eve-Online API Trawler
 *
 */
require_once('includes/class.alliances.php');

class AlliancesAPI
{
	function AlliancesAPI()
    {
		$this->CacheTime_ = ApiCache::get('Alliances');
		$this->CurrentTime_ = ApiCurrent::get('Alliances');
    }
	
	function fetch()
	{
		$Alliance = new AlliancesDB();
		
		if ($this->CacheTime_ == "")
    	{
        	$this->CacheTime_ = "2005-01-01 00:00:00"; // fake date to ensure that it runs first time.
    	}
		
		
		if (is_file(getcwd().'/cache/Alliances.xml'))
			$cacheexists = true;
		else
			$cacheexists = false;
		
		if ((strtotime(gmdate("M d Y H:i:s")) - strtotime($this->CacheTime_) > 0) || !$cacheexists )
        {
            // Load new XML
			$xmlString = @file_get_contents( "http://api.eve-online.com/eve/AllianceList.xml.aspx" );
        	$xml = simplexml_load_string( $xmlString );
		} else {
			// Under Cache Timer - with this class there is no need to reload cached xml file and update DB
			return false;
		}

        if( isset($xml->error) )
        {
			$this->error_ = $xml->error;
			// suppress errors/warnings incase file does not exist
            $xml = @simplexml_load_file( "cache/Alliances.xml" );
        }
        else
        {
            file_put_contents( "cache/Alliances.xml", $xmlString );
        }
        
        if( !$xml->result->rowset->row )
			return false;
		
		// Set Cached Time
		if ($xml->cachedUntil)
		{
			$this->CacheTime_ = $xml->cachedUntil;
			$this->CurrentTime_ = $xml->currentTime;
			ApiCache::set('Alliances', $this->CacheTime_);
			ApiCurrent::set('Alliances', $this->CurrentTime_);
		}
		
		// collect Alliances
		foreach( $xml->result->rowset->row as $alliancerow )
        {
			$name = $alliancerow['name'];
			$shortName = $alliancerow['shortName'];
			$allianceID = $alliancerow['allianceID'];
			$executorCorpID = $alliancerow['executorCorpID'];
			$memberCount = $alliancerow['memberCount'];
			$startDate = $alliancerow['startDate'];
			
			// collect corps with alliance and add to DB
			foreach ($alliancerow->rowset->row as $corprow)
			{
				$Alliance->add($name, $shortName, $allianceID, $executorCorpID, $memberCount, $startDate,
								 $corprow['corporationID'], $corprow['startDate']);
			}
		}

		return true;
	}
}
?>