<?php
/**
 * Eve-Online API Trawler
 *
 */
require_once('includes/class.conquerablestations.php');

class ConquerableStationsAPI
{
	function ConquerableStationsAPI()
    {
		$this->CacheTime_ = ApiCache::get('ConquerableStations');
		$this->CurrentTime_ = ApiCurrent::get('ConquerableStations');
    }
	
	function fetch()
	{
		$station = new ConquerableStationsDB();
		
		if ($this->CacheTime_ == "")
    	{
        	$this->CacheTime_ = "2005-01-01 00:00:00"; // fake date to ensure that it runs first time.
    	}
		
		if (is_file(getcwd().'/cache/ConquerableStations.xml'))
			$cacheexists = true;
		else
			$cacheexists = false;
		
		if ((strtotime(gmdate("M d Y H:i:s")) - strtotime($this->CacheTime_) > 0) || !$cacheexists )
        {
            // Load new XML
			$xmlString = @file_get_contents( "http://api.eve-online.com/eve/ConquerableStationList.xml.aspx" );
        	$xml = simplexml_load_string( $xmlString );
		} else {
			// Under Cache Timer - with this class there is no need to reload cached xml file and update DB
			return false;
		}
        
		if( isset($xml->error) )
        {
			$this->error_ = $xml->error;
            $xml = simplexml_load_file( "cache/ConquerableStations.xml" );
        } else {
            file_put_contents( "cache/ConquerableStations.xml", $xmlString );
        }
        
        if( !$xml->result->rowset->row )
			return false;
		
		// Set Cached Time
		if ($xml->cachedUntil)
		{
			$this->CacheTime_ = $xml->cachedUntil;
			$this->CurrentTime_ = $xml->currentTime;
			ApiCache::set('ConquerableStations', $this->CacheTime_);
			ApiCurrent::set('ConquerableStations', $this->CurrentTime_);
		}
		
		foreach( $xml->result->rowset->row as $row )
        {
			$station->add((integer)$row['stationID'], (string)$row['stationName'], (integer)$row['stationTypeID'],
						   (integer)$row['solarSystemID'], (integer)$row['corporationID'], (string)$row['corporationName']);
		}
		return true;
	}
}
?>