<?php
/**
 * Eve-Online API Trawler
 *
 */
require_once('includes/class.reftypes.php');

class RefTypesAPI
{
	function RefTypesAPI()
    {
		$this->CacheTime_ = ApiCache::get('RefTypes');
		$this->CurrentTime_ = ApiCurrent::get('RefTypes');
		
		$this->refTypes_ = array();
    }
	
	function fetch()
	{
		$reftypes = new RefTypesDB();
		
		if ($this->CacheTime_ == "")
    	{
        	$this->CacheTime_ = "2005-01-01 00:00:00"; // fake date to ensure that it runs first time.
    	}
		
		
		if (is_file(getcwd().'/cache/RefTypes.xml'))
			$cacheexists = true;
		else
			$cacheexists = false;
		
		if ((strtotime(gmdate("M d Y H:i:s")) - strtotime($this->CacheTime_) > 0) || !$cacheexists )
        {
            // Load new XML
			$xmlString = @file_get_contents( "http://api.eve-online.com/eve/RefTypes.xml.aspx" );
        	$xml = simplexml_load_string( $xmlString );
		} else {
			// Under Cache Timer - with this class there is no need to reload cached xml file and update DB
			return false;
		}

        if( isset($xml->error) )
        {
			$this->error_ = $xml->error;
			// suppress errors/warnings incase file does not exist
            $xml = @simplexml_load_file( "cache/RefTypes.xml" );
        }
        else
        {
            file_put_contents( "cache/RefTypes.xml", $xmlString );
        }
        
        if( !$xml->result->rowset->row )
			return false;
		
		// Set Cached Time
		if ($xml->cachedUntil)
		{
			$this->CacheTime_ = $xml->cachedUntil;
			$this->CurrentTime_ = $xml->currentTime;
			ApiCache::set('RefTypes', $this->CacheTime_);
			ApiCurrent::set('RefTypes', $this->CurrentTime_);
		}
		
		// collect RefTypes
		foreach( $xml->result->rowset->row as $reftyperow )
        {
			$reftypes->add((integer)$reftyperow['refTypeID'], (string)$reftyperow['refTypeName']);
		}

		return true;
	}
}
?>