<?php
/**
 * Eve-Online API Trawler
 *
 */

class ShareholdersAPI
{
	function ShareholdersAPI( $userID, $apiKey, $charID, $corpID )
    {
		$this->userID_ = $userID;
		$this->charID_ = $charID;
		$this->apiKey_ = $apiKey;
		$this->corpID_ = $corpID;
		
		$this->apiString_ = array( "userID" => $this->userID_, "apiKey" => $this->apiKey_, "characterID" => $this->charID_ );
		
		$this->CacheTime_ = ApiCache::get($this->corpID_ . "_shareholders");
		$this->CurrentTime_ = ApiCurrent::get($this->corpID_ . "_shareholders");
    }
	
	function fetch()
	{
		
		$baseURL = "http://api.eve-online.com/corp/Shareholders.xml.aspx?";
		$fname = "cache/" . $this->corpID_ . "_shareholders.xml";
		

		if ($this->CacheTime_ == "")
    	{
        	$this->CacheTime_ = "2005-01-01 00:00:00"; // fake date to ensure that it runs first time.
    	}
		
		if (is_file(getcwd()."/".$fname))
			$cacheexists = true;
		else
			$cacheexists = false;
		
		if ((strtotime(gmdate("M d Y H:i:s")) - strtotime($this->CacheTime_) > 0) || !$cacheexists )
        {
            // Load new XML
			$xmlString = @file_get_contents( $baseURL . http_build_query( $this->apiString_ ) );
			$this->isCached = false;
			
			if(!isset($xmlString) || $xmlString === false)
				$this->error_ = "API Website not responding.";
		} else {
			// load cached XML
			$xmlString = @file_get_contents( $fname );
			$this->isCached = true;
		}
        $xml = simplexml_load_string( $xmlString );
        
        if( isset($xml->error) )
        {
			$this->error_ = $xml->error;
			// suppress errors/warnings incase file does not exist
            $xml = @simplexml_load_file( $fname );
			$this->isCached = true;
        } else {
            file_put_contents( $fname, $xmlString );
        }
		
		// Set Cached Time
		if ($xml->cachedUntil)
		{
			$this->CacheTime_ = $xml->cachedUntil;
			$this->CurrentTime_ = $xml->currentTime;
			
			ApiCache::set($this->corpID_ . "_shareholders", $this->CacheTime_);
    		ApiCurrent::set($this->corpID_ . "_shareholders", $this->CurrentTime_);
		}
		
		if ($this->isCached)
		{
			$this->output_ = "using cached file from: " . $this->CurrentTime_ . " and is cached until: " . $this->CacheTime_;
		} else {
			$this->output_ = "received new XML at: " . $this->CurrentTime_;
		}
		
		if( !$xml->result->rowset )
			return false;
		
		// collect data from rows
		foreach( $xml->result->rowset as $rowset )
        {
			//collect Character Shareholders info
			if ($rowset['name'] == "characters")
			{
				foreach ($rowset->row as $row)
				{
					$temp['isCorp'] = 0;
					$temp['shareholderID'] = $row['shareholderID'];
					$temp['shareholderName'] = $row['shareholderName'];
					$temp['shareholderCorporationID'] = $row['shareholderCorporationID'];
					$temp['shareholderCorporationName'] = $row['shareholderCorporationName'];
					$temp['shares'] = $row['shares'];
					
					$shareholders_[] = $temp;
					unset($temp);
				}
			}
			
			//collect Corporation Shareholders info
			if ($rowset['name'] == "corporations")
			{
				foreach ($rowset->row as $row)
				{
					$temp['isCorp'] = 1;
					$temp['shareholderID'] = $row['shareholderID'];
					$temp['shareholderName'] = $row['shareholderName'];
					$temp['shareholderCorporationID'] = NULL;
					$temp['shareholderCorporationName'] = NULL;
					$temp['shares'] = $row['shares'];
					
					$shareholders_[] = $temp;
					unset($temp);
				}
			}
		}
		
		return $shareholders_;
	}
}
?>