<?php
/**
 * Eve-Online API Trawler
 *
 */

class SkillInTrainingAPI
{
	function SkillInTrainingAPI( $userID, $apiKey, $charID )
    {
		$this->userID_ = $userID;
		$this->charID_ = $charID;
		$this->apiKey_ = $apiKey;
        $this->apiString_ = array( "userID" => $userID, "apiKey" => $apiKey, "characterID" => $charID );
		
		$this->CacheTime_ = ApiCache::get($this->charID_ . "_skillintraining");
		$this->CurrentTime_ = ApiCurrent::get($this->charID_ . "_skillintraining");
		
		// define arrays
		$this->skills_ = array();
		$this->attribs_ = array();
    }
	
	function fetch()
	{
		$baseURL = "http://api.eve-online.com/char/SkillInTraining.xml.aspx?";
		$fname = "cache/" . $this->charID_ . "_skillintraining.xml";
		
		if ($this->CacheTime_ == "")
    	{
        	$this->CacheTime_ = "2005-01-01 00:00:00"; // fake date to ensure that it runs first time.
    	}
		
		if (is_file(getcwd() . "/" . $fname))
			$cacheexists = true;
		else
			$cacheexists = false;
		
		if ((strtotime(gmdate("M d Y H:i:s")) - strtotime($this->CacheTime_) > 0) || !$cacheexists )
        {
            // Load new XML
			$xmlString = @file_get_contents( $baseURL . http_build_query( $this->apiString_ ) );
			$this->isCached = false;
			
        	if(!isset($xmlString) || $xmlString === false)
				$this->error_ = "API Website not responding.";
		} else {
			// load cached XML
			$xmlString = @file_get_contents( $fname );
			$this->isCached = true;
		}
        $xml = simplexml_load_string( $xmlString );
		
        if( isset($xml->error) )
        {
			$this->error_ = $xml->error;
            $xml = @simplexml_load_file( $fname );
			$this->isCached = true;
        } else {
            file_put_contents( $fname, $xmlString );
        }
		
		// Set Cached Time
		if ($xml->cachedUntil)
		{
			$this->CacheTime_ = $xml->cachedUntil;
			$this->CurrentTime_ = $xml->currentTime;
			ApiCache::set($this->charID_ . "_skillintraining", $this->CacheTime_);
			ApiCurrent::set($this->charID_ . "_skillintraining", $this->CurrentTime_);
		}
		
		if ($this->isCached)
		{
			$this->output_ = "using cached file from: " . $this->CurrentTime_ . " and is cached until: " . $this->CacheTime_;
		} else {
			$this->output_ = "received new XML at: " . $this->CurrentTime_;
		}
		
		if ( !$xml->result )
			return false;
		
		// collect skill training info
		$this->skillinfo_['currentTQTime'] = $xml->result->currentTQTime;
		$this->skillinfo_['trainingEndTime'] = $xml->result->trainingEndTime;
		$this->skillinfo_['trainingStartTime'] = $xml->result->trainingStartTime;
		$this->skillinfo_['trainingTypeID'] = $xml->result->trainingTypeID;
		$this->skillinfo_['trainingStartSP'] = $xml->result->trainingStartSP;
		$this->skillinfo_['trainingDestinationSP'] = $xml->result->trainingDestinationSP;
		$this->skillinfo_['trainingToLevel'] = $xml->result->trainingToLevel;
		$this->skillinfo_['skillInTraining'] = $xml->result->skillInTraining;

		return;
	}
}
?>