<?php
/**
 * Eve-Online API Trawler
 *
 */
require_once('includes/class.skilltree.php');

class SkillTreeAPI
{
	function SkillTreeAPI()
    {
		$this->CacheTime_ = ApiCache::get('SkillTree');
		$this->CurrentTime_ = ApiCurrent::get('SkillTree');
    }
	
	function fetch()
	{
		$skilltree = new SkillTree();
		
		if ($this->CacheTime_ == "")
    	{
        	$this->CacheTime_ = "2005-01-01 00:00:00"; // fake date to ensure that it runs first time.
    	}
		
		
		if (is_file(getcwd().'/cache/SkillTree.xml'))
			$cacheexists = true;
		else
			$cacheexists = false;
		
		if ((strtotime(gmdate("M d Y H:i:s")) - strtotime($this->CacheTime_) > 0) || !$cacheexists )
        {
            // Load new XML
			$xmlString = @file_get_contents( "http://api.eve-online.com/eve/SkillTree.xml.aspx" );
        	$xml = simplexml_load_string( $xmlString );
		} else {
			// Under Cache Timer - with this class there is no need to reload cached xml file and update DB
			return false;
		}
        
		if( isset($xml->error) )
        {
			$this->error_ = $xml->error;
            $xml = simplexml_load_file( "cache/SkillTree.xml" );
        } else {
            file_put_contents( "cache/SkillTree.xml", $xmlString );
        }
        
        if( !$xml->result->rowset->row )
			return false;
		
		// Set Cached Time
		if ($xml->cachedUntil)
		{
			$this->CacheTime_ = $xml->cachedUntil;
			$this->CurrentTime_ = $xml->currentTime;
			ApiCache::set('SkillTree', $this->CacheTime_);
			ApiCurrent::set('SkillTree', $this->CurrentTime_);
		}
		
		foreach( $xml->result->rowset->row as $grouprow )
        {
			$skilltree->addGroup($grouprow['groupID'], $grouprow['groupName']);
	
			foreach ($grouprow->rowset->row as $skillrow)
			{
				$skilltree->addSkill($skillrow['typeID'], $skillrow['groupID'], $skillrow['typeName']);
			}
		
		}
		return true;
	}
}
?>