<?php
/**
 * Eve-Online API Trawler
 *
 */
require_once('includes/class.systems.php');

// This class uses /map/Sovereignty.xml.aspx API to locate and identify all systems

class SystemsAPI
{
	function SystemsAPI( )
    {
		$this->CacheTime_ = ApiCache::get('Sovereignty');
		$this->CurrentTime_ = ApiCurrent::get('Sovereignty');
    }
	
	function fetch()
	{
		$System = new SystemsDB();
		
		if ($this->CacheTime_ == "")
    	{
        	$this->CacheTime_ = "2005-01-01 00:00:00"; // fake date to ensure that it runs first time.
    	}
		
		
		if (is_file(getcwd().'/cache/Sovereignty.xml'))
			$cacheexists = true;
		else
			$cacheexists = false;
		
		if ((strtotime(gmdate("M d Y H:i:s")) - strtotime($this->CacheTime_) > 0) || !$cacheexists )
        {
            // Load new XML
			$xmlString = @file_get_contents( "http://api.eve-online.com/map/Sovereignty.xml.aspx" );
        	$xml = simplexml_load_string( $xmlString );
		} else {
			// Under Cache Timer - with this class there is no need to reload cached xml file and update DB
			return false;
		}
		
        if( isset($xml->error) )
        {
			$this->error_ = $xml->error;
			// suppress errors/warnings incase file does not exist
            $xml = @simplexml_load_file( "cache/Sovereignty.xml" );
        } else {
            file_put_contents( "cache/Sovereignty.xml", $xmlString );
        }
        
        if( !$xml->result->rowset->row )
			return false;
		
		// Set Cached Time
		if ($xml->cachedUntil)
		{
			$this->CacheTime_ = $xml->cachedUntil;
			$this->CurrentTime_ = $xml->currentTime;
			ApiCache::set('Sovereignty', $this->CacheTime_);
			ApiCurrent::set('Sovereignty', $this->CurrentTime_);
		}
		
		// collect Systems and add to Database
		foreach( $xml->result->rowset->row as $row )
        {
		
			$System->add( $row['solarSystemID'], $row['allianceID'], $row['constellationSovereignty'], $row['sovereigntyLevel'],
						  $row['factionID'],  $row['solarSystemName']);
		}

		return true;
	}
}
?>