<?php
/**
 * Eve-Online API Trawler
 *
 */

class WalletJournalAPI
{
	function WalletJournalAPI( $userID, $apiKey, $charID, $accountKey = 1000, $corpID = 0 )
    {
		$this->userID_ = $userID;
		$this->charID_ = $charID;
		$this->apiKey_ = $apiKey;
		$this->accountKey_ = $accountKey;
		$this->beforeRefID_ = $beforeRefID;
		$this->corpID_ = $corpID;

		$this->entry_ = array();
		
		if ($this->corpID_ != 0)
		{
			$this->CacheTime_ = ApiCache::get($this->corpID_ . "_" . $this->accountKey_ . "_corpwalletjournal");
			$this->CurrentTime_ = ApiCurrent::get($this->corpID_ . "_" . $this->accountKey_ . "_corpwalletjournal");
		} else {
			$this->CacheTime_ = ApiCache::get($this->charID_ . "_walletjournal");
			$this->CurrentTime_ = ApiCurrent::get($this->charID_ . "_walletjournal");
		}
    }
	
	function fetch()
	{
		if ($this->corpID_ != 0)
		{
			$baseURL = "http://api.eve-online.com/corp/WalletJournal.xml.aspx?";
			$fname = "cache/" . $this->corpID_ . "_" . $this->accountKey_ . "_corpwalletjournal.xml";
		} else {
			$baseURL = "http://api.eve-online.com/char/WalletJournal.xml.aspx?";
			$fname = "cache/" . $this->charID_ . "_walletjournal.xml";
		}
		
		if ($this->CacheTime_ == "")
    	{
        	$this->CacheTime_ = "2005-01-01 00:00:00"; // fake date to ensure that it runs first time.
    	}
		
		if (is_file(getcwd()."/".$fname))
			$cacheexists = true;
		else
			$cacheexists = false;
		
		if ((strtotime(gmdate("M d Y H:i:s")) - strtotime($this->CacheTime_) > 0) || !$cacheexists )
        {
            // Load new XML
			unset($xml);
			unset($xmlString);
		
			$lastrefid = 1;
        	$currentrefid = 0;
		
			$xmlString = '<?xml version="1.0" encoding="UTF-8" ?><myxml thunkage="1">';
			do {
				$this->beforeRefID = $currentrefid;

				if ($this->beforeRefID == 0)
				{
					$this->apiString_ = array( "accountKey" => $this->accountKey_, "userID" => $this->userID_,
						 "apiKey" => $this->apiKey_, "characterID" => $this->charID_ );
				} else {
				$this->apiString_ = array( "accountKey" => $this->accountKey_, "beforeRefID" => $this->beforeRefID,
						 "userID" => $this->userID_, "apiKey" => $this->apiKey_, "characterID" => $this->charID_ );
				}
			
				$contents = @file_get_contents( $baseURL . http_build_query( $this->apiString_ ) );
				$start = strpos($contents, "?>");
            	if ($start != false)
            	{
                	$xmlString .= substr($contents, $start + strlen("\r\n\r\n"));
            	}
				//$tempXML = $xmlString . '</myxml>';
        		//$xml = simplexml_load_string( $tempXML );
		
				$lastrefid = $currentrefid;
           	 	$currentrefid = getlastid($xmlString, 'refID="');
			} while ( $lastrefid != $currentrefid );
        	$xmlString .= '</myxml>'; 
			
			$this->isCached = false;
			//if(!isset($xmlString)) // doesn't work here as we artificially set $xmlString (it's always gonna be set)
				//$this->error_ = "API Website not responding.";
		} else {
			// load cached XML
			$xmlString = @file_get_contents( $fname );
			$this->isCached = true;
		}
        $xml = simplexml_load_string( $xmlString );
	
        if( isset($xml->eveapi->error) )
        {
			if ($xml->eveapi->error['code'] != 101)
		   	{
				$this->error_ = $xml->eveapi->error . "[" . $xml->eveapi->error['code'] . "]";
		   		$xml = @simplexml_load_file( $fname );
		   	} else {
				// Load file and do not mention the 101 error
				//$this->error_ = $xml->eveapi->error;
				$xml = @simplexml_load_file( $fname );
		   	}
			$this->isCached = true;
        } else {
			file_put_contents( $fname, $xmlString );
		}
		
		// Set Cached Time
		if ($xml->eveapi->cachedUntil)
		{
			$this->CacheTime_ = $xml->eveapi->cachedUntil;
			$this->CurrentTime_ = $xml->eveapi->currentTime;
			
			if ($this->corpID_ != 0)
			{
				ApiCache::set($this->corpID_ . "_" . $this->accountKey_ . "_corpwalletjournal", $this->CacheTime_);
    			ApiCurrent::set($this->corpID_ . "_" . $this->accountKey_ . "_corpwalletjournal", $this->CurrentTime_);
			} else {
				ApiCache::set($this->charID_ . "_walletjournal", $this->CacheTime_);
				ApiCurrent::set($this->charID_ . "_walletjournal", $this->CurrentTime_);
			}
		}
		
		if ($this->isCached)
		{
			$this->output_ = "using cached file from: " . $this->CurrentTime_ . " and is cached until: " . $this->CacheTime_;
		} else {
			$this->output_ = "received new XML at: " . $this->CurrentTime_;
		}
		
		if( !$xml->eveapi->result->rowset->row )
			return false;
		
		// collect data from rows
		foreach( $xml->eveapi as $xmlpage)
        {	
			if( !$xmlpage->result->rowset->row )
				break;
			
			foreach( $xmlpage->result->rowset->row as $row)
			{
				$this->entry_[] = $row;	
			}
		}
		
		return;
	}
}
?>