<?php
class ApiCache
{
    function ApiCache()
    {
        ApiCache::init();
    }

    function init()
    {
        global $ApiCache_init;

        if ($ApiCache_init)
        {
            return;
        }

        $db = new DBQuery(true);
		$db->execute("CREATE TABLE IF NOT EXISTS `cachetimers` (
 			 `xml_sheet` varchar(64) NOT NULL default '',
  			 `cachedUntil` DATETIME NOT NULL,
  			 PRIMARY KEY  (`xml_sheet`)
			 )");
        $db->execute('select * from cachetimers');
        $ApiCache = &ApiCache::_getCache();
        while ($row = $db->getRow())
        {
            if (substr($row['cachedUntil'], 0, 2) == 'a:')
            {
                $row['cachedUntil'] = unserialize($row['cachedUntil']);
            }
            $ApiCache[$row['xml_sheet']] = $row['cachedUntil'];
        }
        $ApiCache_init = true;
    }

	function &_getCache()
    {
    	static $cache;

    	if (!isset($cache))
        {
    	    $cache = array();
    	}
    	return $cache;
    }
	
    function put($key, $data)
    {
    	$cache = &ApiCache::_getCache();
    	$cache[$key] = $data;
    }

    function del($key)
    {
    	$cache = &ApiCache::_getCache();
    	if (isset($cache[$key]))
    	{
    	    unset($cache[$key]);
    	}

        $qry = new DBQuery();
        $qry->execute("delete from cachetimers where xml_sheet = '".$key."'");
    }

    function set($key, $value)
    {
    	$cache = &ApiCache::_getCache();

    	// only update the database when the old value differs
    	if (isset($cache[$key]))
    	{
    	    if ($cache[$key] === $value)
    	    {
    	        return;
    	    }
    	}

    	if (is_array($value))
    	{
    	    $cache[$key] = $value;
    	    $value = serialize($value);
    	}
    	else
    	{
    	    $cache[$key] = stripslashes($value);
        }
        $value = addslashes($value);

        $qry = new DBQuery();
        $qry->execute("select cachedUntil from cachetimers
                       where xml_sheet = '".$key."'");
        if ($qry->recordCount())
        {
            $sql = "update cachetimers set cachedUntil = '".$value."'
                    where xml_sheet = '".$key."'";
        }
        else
        {
            $sql = "insert into cachetimers values ('".$key."','".$value."')";
        }
        $qry->execute($sql);
    }

    function &get($key)
    {
    	$cache = &ApiCache::_getCache();

    	if (!isset($cache[$key]))
    	{
    	    //return "<i>never</i>"; // looks neater, but caching system expects "" so may cause problems
			return "";
    	}
    	return stripslashes($cache[$key]);
    }

	function &getnumerical($key)
    {
    	$cache = &ApiCache::_getCache();

    	if (!isset($cache[$key]))
    	{
    	    return ApiCache::defaultval($key);
    	}
    	return $cache[$key];
    }
    function defaultval($key)
    {
        // add important upgrade configs here, they will return the default if not set
        // they will be shown as set but take no space in the database
        //$defaults = array('summarytable_rowcount' => 8);
		//$defaults = array('killcount' => 50);
		
        if (!isset($defaults[$key]))
        {
            return null;
        }
        return $defaults[$key];
    }
}

class ApiCurrent
{
    function ApiCurrent()
    {
        ApiCurrent::init();
    }

    function init()
    {
        global $ApiCurrent_init;

        if ($ApiCurrent_init)
        {
            return;
        }

        $db = new DBQuery(true);
		$db->execute("CREATE TABLE IF NOT EXISTS `currenttimers` (
 			 `xml_sheet` varchar(64) NOT NULL default '',
  			 `currentTime` DATETIME NOT NULL,
  			 PRIMARY KEY  (`xml_sheet`)
			 )");
        $db->execute('select * from currenttimers');
        $ApiCurrent = &ApiCurrent::_getCache();
        while ($row = $db->getRow())
        {
            if (substr($row['currentTime'], 0, 2) == 'a:')
            {
                $row['currentTime'] = unserialize($row['currentTime']);
            }
            $ApiCurrent[$row['xml_sheet']] = $row['currentTime'];
        }
        $ApiCurrent_init = true;
    }

	function &_getCache()
    {
    	static $cache;

    	if (!isset($cache))
        {
    	    $cache = array();
    	}
    	return $cache;
    }
	
    function put($key, $data)
    {
    	$cache = &ApiCurrent::_getCache();
    	$cache[$key] = $data;
    }

    function del($key)
    {
    	$cache = &ApiCurrent::_getCache();
    	if (isset($cache[$key]))
    	{
    	    unset($cache[$key]);
    	}

        $qry = new DBQuery();
        $qry->execute("delete from currenttimers where xml_sheet = '".$key."'");
    }

    function set($key, $value)
    {
    	$cache = &ApiCurrent::_getCache();

    	// only update the database when the old value differs
    	if (isset($cache[$key]))
    	{
    	    if ($cache[$key] === $value)
    	    {
    	        return;
    	    }
    	}

    	if (is_array($value))
    	{
    	    $cache[$key] = $value;
    	    $value = serialize($value);
    	}
    	else
    	{
    	    $cache[$key] = stripslashes($value);
        }
        $value = addslashes($value);

        $qry = new DBQuery();
        $qry->execute("select currentTime from currenttimers
                       where xml_sheet = '".$key."'");
        if ($qry->recordCount())
        {
            $sql = "update currenttimers set currentTime = '".$value."'
                    where xml_sheet = '".$key."'";
        }
        else
        {
            $sql = "insert into currenttimers values ('".$key."','".$value."')";
        }
        $qry->execute($sql);
    }

    function &get($key)
    {
    	$cache = &ApiCurrent::_getCache();

    	if (!isset($cache[$key]))
    	{
    	    //return "<i>never</i>"; // looks neater, but caching system expects "" so may cause problems
			return "";
    	}
    	return stripslashes($cache[$key]);
    }

	function &getnumerical($key)
    {
    	$cache = &ApiCurrent::_getCache();

    	if (!isset($cache[$key]))
    	{
    	    return ApiCurrent::defaultval($key);
    	}
    	return $cache[$key];
    }
    function defaultval($key)
    {
        // add important upgrade configs here, they will return the default if not set
        // they will be shown as set but take no space in the database
        //$defaults = array('summarytable_rowcount' => 8);
		//$defaults = array('killcount' => 50);
		
        if (!isset($defaults[$key]))
        {
            return null;
        }
        return $defaults[$key];
    }
}
?>
