<?php

class Character
{
    function Character($charid = 0)
    {
        $this->characterID_ = $charid;
        $this->qry_ = new DBQuery();
		
		// check if DB exists, if not - create it
		$this->qry_->execute("CREATE TABLE IF NOT EXISTS `characters` (
								`playerID` INT UNSIGNED NOT NULL ,
								`userID` INT UNSIGNED NOT NULL ,
								`characterID` INT UNSIGNED NOT NULL ,
								`name` VARCHAR( 64 ) NOT NULL ,
								`race` VARCHAR( 64 ) NOT NULL ,
								`bloodLine` VARCHAR( 64 ) NOT NULL ,
								`gender` VARCHAR( 7 ) NOT NULL ,
								`corporationName` VARCHAR( 64 ) NOT NULL ,
								`corporationID` INT UNSIGNED NOT NULL ,
								`cloneName` VARCHAR( 64 ) NOT NULL ,
								`cloneSkillPoints` INT UNSIGNED NOT NULL ,
								`balance` DECIMAL(15,2) NOT NULL ,
								`intelligence` FLOAT NOT NULL ,
								`memory` FLOAT NOT NULL ,
								`charisma` FLOAT NOT NULL ,
								`perception` FLOAT NOT NULL ,
								`willpower` FLOAT NOT NULL ,
								`slot1` VARCHAR( 64 ) NOT NULL ,
								`slot2` VARCHAR( 64 ) NOT NULL ,
								`slot3` VARCHAR( 64 ) NOT NULL ,
								`slot4` VARCHAR( 64 ) NOT NULL ,
								`slot5` VARCHAR( 64 ) NOT NULL ,
								`director` SMALLINT UNSIGNED NOT NULL ,
								`creationDate` DATE NULL ,
								`lastUpdated` DATETIME NOT NULL ,
								PRIMARY KEY ( `characterID` ) ,
								INDEX ( `playerID` ) ,
								INDEX ( `userID` )
								) ENGINE = MYISAM" );
    }

    function getID()
    {
        return $this->characterID_;
    }

    function getName()
    {
        $this->execQuery();
        return $this->row_['name'];
    }

    function lookup($name)
    {
        $this->qry_->execute("select * from characters
                       where name = '" . slashfix($name) . "'");
        $row = $this->qry_->getRow();
        if ($row['characterID']) $this->characterID_ = $row['characterID'];
    }

    function execQuery()
    {
        if (!$this->qry_->executed_)
        {
            $this->sql_ = "select * from characters
	  	                   where characterID = " . $this->characterID_;
            $this->qry_->execute($this->sql_);
            $this->row_ = $this->qry_->getRow();
        }
    }

    function add($playerid, $userid, $characterid, $name, $race, $bloodline, $gender, $corporationname, $corporationid, $clonename,
	 $cloneskillpoints, $balance, $intelligence, $memory, $charisma, $perception, $willpower, $slot1, $slot2, $slot3, $slot4, $slot5,
	 $isdirector, $timestamp)
    {
        $this->qry_->execute("select * from characters
		               where characterID = " . $characterid );

        if ($this->qry_->recordCount() == 0)
        {							 
            $this->qry_->execute("insert into characters (playerID, userID, characterID, name, race, bloodLine, 
									gender, corporationName, corporationID, cloneName, cloneSkillPoints, balance, 
									intelligence, memory, charisma, perception, willpower, slot1, slot2, slot3, slot4, slot5,
									 director, lastUpdated )
									 values ( '" . $playerid . "','" . $userid . "','"
									 . $characterid . "','"
									 . slashfix($name) . "','"
									 . slashfix($race) . "','"
									 . slashfix($bloodline) . "','"
									 . slashfix($gender) . "','"
									 . slashfix($corporationname) . "','"
									 . $corporationid . "','"
									 . slashfix($clonename) . "','"
									 . $cloneskillpoints . "','"
									 . slashfix($balance) . "','"
									 . $intelligence . "','"
									 . $memory . "','"
									 . $charisma . "','"
									 . $perception . "','"
									 . $willpower . "','"
									 . slashfix($slot1) . "','"
									 . slashfix($slot2) . "','"
									 . slashfix($slot3) . "','"
									 . slashfix($slot4) . "','"
									 . slashfix($slot5) . "','"
									 . $isdirector . "',date_format('" . $timestamp . "','%Y.%m.%d %H:%i:%s'))" );
            $this->characterID_ = $characterid;
        }
        else
        {
            $row = $this->qry_->getRow();
            $this->characterID_ = $row['characterID'];
            
            $this->qry_->execute("update characters
	                       	set playerID = '" . $playerid . "', 
	                       	userID = '" . $userid . "',
							name = '" . slashfix($name) . "',
							race = '" . slashfix($race) . "',
							bloodLine = '" . slashfix($bloodline) . "',
							gender = '" . slashfix($gender) . "',
							corporationName = '" . slashfix($corporationname) . "',
							corporationID = '" . $corporationid . "',
							cloneName = '" . slashfix($clonename) . "',
							cloneSkillPoints = '" . $cloneskillpoints . "',
							balance = '" . $balance . "',
							intelligence = '" . $intelligence . "',
							memory = '" . $memory . "',
							charisma = '" . $charisma . "',
							perception = '" . $perception . "',
							willpower = '" . $willpower . "',
							slot1 = '" . slashfix($slot1) . "',
							slot2 = '" . slashfix($slot2) . "',
							slot3 = '" . slashfix($slot3) . "',
							slot4 = '" . slashfix($slot4) . "',
							slot5 = '" . slashfix($slot5) . "',
							director = '" . $isdirector . "',
							lastUpdated = date_format('" . $timestamp . "','%Y.%m.%d %H:%i:%s') 
			              	where characterID = " . $this->characterID_);
        }

        return $this->characterID_;
    }
	
	function updateCreationDate($characterid, $datestamp)
	{
		$this->qry_->execute("select * from characters
		               where characterID = " . $characterid );
		
		if ($this->qry_->recordCount() != 0)
        {
			$row = $this->qry_->getRow();
            $this->characterID_ = $row['characterID'];
			
			$this->qry_->execute("update characters
							set creationDate = date_format('" . $datestamp . "','%Y.%m.%d')  
			               	where characterID = " . $this->characterID_);
		}
	}
}
?>
