<?php

class CorporationDB
{
    function CorporationDB($corpID = 0)
    {
        $this->corporationID_ = $corpID;
        $this->qry_ = new DBQuery();
		
		// check if DB exists, if not - create it
		$this->qry_->execute("CREATE TABLE IF NOT EXISTS `corporations` (
								`corporationID` INT UNSIGNED NOT NULL ,
								`corporationName` VARCHAR( 64 ) NOT NULL ,
								`ticker` VARCHAR( 6 ) NOT NULL ,
								`ceoID` INT UNSIGNED NOT NULL ,
								`ceoName` VARCHAR( 64 ) NOT NULL ,
								`stationID` INT UNSIGNED NOT NULL ,
								`stationName` VARCHAR( 64 ) NOT NULL ,
								`description` TEXT CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL ,
								`url` VARCHAR( 64 ) NOT NULL ,
								`allianceID` INT UNSIGNED NOT NULL ,
								`allianceName` VARCHAR( 64 ) NOT NULL ,
								`taxRate` DECIMAL(3,1) NOT NULL ,
								`memberCount` INT UNSIGNED NOT NULL ,
								`memberLimit` INT UNSIGNED NOT NULL ,
								`shares` INT UNSIGNED NOT NULL ,
								`div1` VARCHAR( 64 ) NOT NULL ,
								`div2` VARCHAR( 64 ) NOT NULL ,
								`div3` VARCHAR( 64 ) NOT NULL ,
								`div4` VARCHAR( 64 ) NOT NULL ,
								`div5` VARCHAR( 64 ) NOT NULL ,
								`div6` VARCHAR( 64 ) NOT NULL ,
								`div7` VARCHAR( 64 ) NOT NULL ,
								`wal1` VARCHAR( 64 ) NOT NULL ,
								`wal2` VARCHAR( 64 ) NOT NULL ,
								`wal3` VARCHAR( 64 ) NOT NULL ,
								`wal4` VARCHAR( 64 ) NOT NULL ,
								`wal5` VARCHAR( 64 ) NOT NULL ,
								`wal6` VARCHAR( 64 ) NOT NULL ,
								`wal7` VARCHAR( 64 ) NOT NULL ,
								`lastUpdated` DATETIME NOT NULL ,
								PRIMARY KEY ( `corporationID` ) ,
								INDEX ( `allianceID` )
								) ENGINE = MYISAM" );
    }

    function getID()
    {
        return $this->corporationID_;
    }

    function lookup($name)
    {
        $this->qry_->execute("select * from corporations
                       where corporationName = '" . slashfix($name) . "'");
        $row = $this->qry_->getRow();
        if ($row['corporationID']) $this->corporationID_ = $row['corporationID'];
    }

    function add($corporationID, $corporationName, $ticker, $ceoID, $ceoName, $stationID, $stationName, $description, $url, $allianceID,
				 $allianceName, $taxRate, $memberCount, $memberLimit, $shares, $div1, $div2, $div3, $div4, $div5, $div6, $div7, $wal1,
				 $wal2, $wal3, $wal4, $wal5, $wal6, $wal7, $timestamp)
    {
        $this->qry_->execute("select * from corporations
		               where corporationID = " . $corporationID );

        if ($this->qry_->recordCount() == 0)
        {							 
            $this->qry_->execute("insert into corporations (corporationID, corporationName, ticker, ceoID, ceoName, stationID, 
									stationName, description, url, allianceID, allianceName, taxRate, memberCount, memberLimit,
									shares, div1, div2, div3, div4, div5, div6, div7, wal1, wal2, wal3, wal4, wal5, wal6, wal7,
									lastUpdated )
									values ( '" . $corporationID . "','" . slashfix($corporationName) . "','"
									. slashfix($ticker) . "','"
									. $ceoID . "','"
									. slashfix($ceoName) . "','"
									. $stationID . "','"
									. slashfix($stationName) . "','"
									. slashfix($description) . "','"
									. slashfix($url) . "','"
									. $allianceID . "','"
									. slashfix($allianceName) . "','"
									. slashfix($taxRate) . "','"
									. $memberCount . "','"
									. $memberLimit . "','"
									. slashfix($shares) . "','"
									. slashfix($div1) . "','"
									. slashfix($div2) . "','"
									. slashfix($div3) . "','"
									. slashfix($div4) . "','"
									. slashfix($div5) . "','"
									. slashfix($div6) . "','"
									. slashfix($div7) . "','"
									. slashfix($wal1) . "','"
									. slashfix($wal2) . "','"
									. slashfix($wal3) . "','"
									. slashfix($wal4) . "','"
									. slashfix($wal5) . "','"
									. slashfix($wal6) . "','"
									. slashfix($wal7) 
									. "',date_format('" . $timestamp . "','%Y.%m.%d %H:%i:%s'))" );
            $this->corporationID_ = $corporationID;
        }
        else
        {
            $row = $this->qry_->getRow();
            $this->corporationID_ = $row['corporationID'];
            
            $this->qry_->execute("update corporations
	                       	set corporationName = '" . slashfix($corporationName) . "', 
	                       	ticker = '" . slashfix($ticker) . "',
							ceoID = '" . $ceoID . "',
							ceoName = '" . slashfix($ceoName) . "',
							stationID = '" . $stationID . "',
							stationName = '" . slashfix($stationName) . "',
							description = '" . slashfix($description) . "',
							url = '" . slashfix($url) . "',
							allianceID = '" . $allianceID  . "',
							allianceName = '" . slashfix($allianceName) . "',
							taxRate = '" . slashfix($taxRate) . "',
							memberCount = '" . $memberCount . "',
							memberLimit = '" . $memberLimit . "',
							shares = '" . $shares . "',
							div1 = '" . slashfix($div1) . "',
							div2 = '" . slashfix($div2) . "',
							div3 = '" . slashfix($div3) . "',
							div4 = '" . slashfix($div4) . "',
							div5 = '" . slashfix($div5) . "',
							div6 = '" . slashfix($div6) . "',
							div7 = '" . slashfix($div7) . "',
							wal1 = '" . slashfix($wal1) . "',
							wal2 = '" . slashfix($wal2) . "',
							wal3 = '" . slashfix($wal3) . "',
							wal4 = '" . slashfix($wal4) . "',
							wal5 = '" . slashfix($wal5) . "',
							wal6 = '" . slashfix($wal6) . "',
							wal7 = '" . slashfix($wal7) . "',
							lastUpdated = date_format('" . $timestamp . "','%Y.%m.%d %H:%i:%s')
			              	 where corporationID = " . $this->corporationID_);
        }

        return $this->corporationID_;
    }
}
?>
