<?php

class IndustryJobsDB
{
    function IndustryJobsDB($jobid = 0)
    {
        $this->jobID_ = $jobid;
        $this->qry_ = new DBQuery();
		
		// check if DB exists, if not - create it
		$this->qry_->execute("CREATE TABLE IF NOT EXISTS `industryjobs` (
								`playerID` INT UNSIGNED NOT NULL ,
								`userID` INT UNSIGNED NOT NULL ,
								`ownerID` INT UNSIGNED NOT NULL ,
								`jobID` INT UNSIGNED NOT NULL ,
								`assemblyLineID` INT NOT NULL ,
								`containerID` INT NOT NULL ,
								`installedItemID` INT NOT NULL ,
								`installedItemLocationID` INT NOT NULL ,
								`installedItemQuantity` INT NOT NULL ,
								`installedItemProductivityLevel` INT NOT NULL ,
								`installedItemMaterialLevel` INT NOT NULL ,
								`installedItemLicensedProductionRunsRemaining` INT NOT NULL ,
								`outputLocationID` INT NOT NULL ,
								`installerID` INT NOT NULL ,
								`runs` INT NOT NULL ,
								`licensedProductionRuns` INT NOT NULL ,
								`installedInSolarSystemID` INT NOT NULL ,
								`containerLocationID` INT NOT NULL ,
								`materialMultiplier` FLOAT NOT NULL ,
								`charMaterialMultiplier` FLOAT NOT NULL ,
								`timeMultiplier` FLOAT NOT NULL ,
								`charTimeMultiplier` FLOAT NOT NULL ,
								`installedItemTypeID` INT NOT NULL ,
								`outputTypeID` INT NOT NULL ,
								`containerTypeID` INT NOT NULL ,
								`installedItemCopy` INT NOT NULL ,
								`completed` INT NOT NULL ,
								`completedSuccessfully` INT NOT NULL ,
								`installedItemFlag` INT NOT NULL ,
								`outputFlag` INT NOT NULL ,
								`activityID` INT NOT NULL ,
								`completedStatus` INT NOT NULL ,
								`installTime` DATETIME NOT NULL ,
								`beginProductionTime` DATETIME NOT NULL ,
								`endProductionTime` DATETIME NOT NULL ,
								`pauseProductionTime` DATETIME NOT NULL ,
								`lastUpdated` DATETIME NOT NULL ,
								PRIMARY KEY ( `jobID` ) ,
								INDEX ( `ownerID` ) ,
								INDEX ( `playerID` ) ,
								INDEX ( `userID` ) ,
								INDEX ( `installedInSolarSystemID` )
								) ENGINE = MYISAM" );
    }

    function execQuery()
    {
        if (!$this->qry_->executed_)
        {
            $this->sql_ = "select * from industryjobs
	  	                   where jobID = " . $this->jobID_;
            $this->qry_->execute($this->sql_);
            $this->row_ = $this->qry_->getRow();
        }
    }

	function purge($charid)
	{
		// assets lists are 'complete' therefore we purge previous assets listed to allow the new processing to present 100% accuracy
		$this->sql_ = "DELETE from industryjobs
	  	                   where ownerID = " . $charid;
	}
	
    function add($playerid, $userid, $characterid, $jobid, $assemblylineid, $containerid, $installeditemid, $installeditemlocationid, 				
					$installeditemquantity, $installeditemproductivitylevel, $installeditemmateriallevel, 			
					$installeditemlicensedproductionrunsremaining, $outputlocationid, $installerid, $runs, $licensedproductionruns, 	
					$installedinsolarsystemid, $containerlocationid, $materialmultiplier, $charmaterialmultiplier, $timemultiplier, 
					$chartimemultiplier, $installeditemtypeid, $outputtypeid, $containertypeid, $installeditemcopy, $completed, 
					$completedsuccessfully, $installeditemflag, $outputflag, $activityid, $completedstatus, $installtime, 
					$beginproductiontime, $endproductiontime, $pauseproductiontime, $timestamp)
    {
       	 $this->qry_->execute("select * from industryjobs
		               where jobID = " . $jobid );

        if ($this->qry_->recordCount() == 0)
       	 {										 				 
            $this->qry_->execute("insert into industryjobs (playerID, userID, ownerID, jobID, assemblyLineID, containerID, 
									installedItemID, installedItemLocationID, installedItemQuantity, installedItemProductivityLevel,
									installedItemMaterialLevel, installedItemLicensedProductionRunsRemaining, outputLocationID,
									installerID, runs, licensedProductionRuns, installedInSolarSystemID, containerLocationID,
									materialMultiplier, charMaterialMultiplier, timeMultiplier, charTimeMultiplier, installedItemTypeID,
									outputTypeID, containerTypeID, installedItemCopy, completed, completedSuccessfully, installedItemFlag,
									outputFlag, activityID, completedStatus, installTime, beginProductionTime, endProductionTime,
									pauseProductionTime, lastUpdated ) values ( '" . $playerid . "','" . $userid . "','"
									 . $characterid . "','" . $jobid . "','"
									 . $assemblylineid . "','"
									 . $containerid . "','"
									 . $installeditemid . "','"
									 . $installeditemlocationid . "','"
									 . $installeditemquantity . "','"
									 . $installeditemproductivitylevel . "','"
									 . $installeditemmateriallevel . "','"
									 . $installeditemlicensedproductionrunsremaining . "','"
									 . $outputlocationid . "','"
									 . $installerid . "','"
									 . $runs . "','"
									 . $licensedproductionruns . "','"
									 . $installedinsolarsystemid . "','"
									 . $containerlocationid . "','"
									 . $materialmultiplier . "','"
									 . $charmaterialmultiplier . "','"
									 . $timemultiplier . "','"
									 . $chartimemultiplier . "','"
									 . $installeditemtypeid . "','"
									 . $outputtypeid . "','"
									 . $containertypeid . "','"
									 . $installeditemcopy . "','"
									 . $completed . "','"
									 . $completedsuccessfully . "','"
									 . $installeditemflag . "','"
									 . $outputflag . "','"
									 . $activityid . "','"
									 . $completedstatus
									 . "',date_format('" . $installtime . "','%Y.%m.%d %H:%i:%s'), "
									 . "date_format('" . $beginproductiontime . "','%Y.%m.%d %H:%i:%s'), "
									 . "date_format('" . $endproductiontime . "','%Y.%m.%d %H:%i:%s'), "
									 . "date_format('" . $pauseproductiontime . "','%Y.%m.%d %H:%i:%s'), "
									 . "date_format('" . $timestamp . "','%Y.%m.%d %H:%i:%s'))" );
            $this->jobID_ = $jobid;
        } else {
            $row = $this->qry_->getRow();
            $this->jobID_ = $row['jobID'];
							 			
            $this->qry_->execute("update industryjobs
	                       	set playerID = '" . $playerid . "', 
	                       	userID = '" . $userid . "',
							ownerID = '" . $characterid . "',
							assemblyLineID = '" . $assemblylineid . "',
							containerID = '" . $containerid . "',
							installedItemID = '" . $installeditemid . "',
							installedItemLocationID = '" . $installeditemlocationid . "',
							installedItemQuantity = '" . $installeditemquantity . "',
							installedItemProductivityLevel = '" . $installeditemproductivitylevel . "',
							installedItemMaterialLevel = '" . $installeditemmateriallevel . "',
							installedItemLicensedProductionRunsRemaining = '" . $installeditemlicensedproductionrunsremaining . "',
							outputLocationID = '" . $outputlocationid . "',
							installerID = '" . $installerid . "',
							runs = '" . $runs . "',
							licensedProductionRuns = '" . $licensedproductionruns . "',
							installedInSolarSystemID = '" . $installedinsolarsystemid . "',
							containerLocationID = '" . $containerlocationid . "',
							materialMultiplier = '" . $materialmultiplier . "',
							charMaterialMultiplier = '" . $charmaterialmultiplier . "',
							timeMultiplier = '" . $timemultiplier . "',
							charTimeMultiplier = '" . $chartimemultiplier . "',
							installedItemTypeID = '" . $installeditemtypeid . "',
							outputTypeID = '" . $outputtypeid . "',
							containerTypeID = '" . $containertypeid . "',
							installedItemCopy = '" . $installeditemcopy . "',
							completed = '" . $completed . "',
							completedSuccessfully = '" . $completedsuccessfully . "',
							installedItemFlag = '" . $installeditemflag . "',
							outputFlag = '" . $outputflag . "',
							activityID = '" . $activityid . "',
							completedStatus = '" . $completedstatus . "',
							installTime = date_format('" . $installtime . "','%Y.%m.%d %H:%i:%s'),
							beginProductionTime = date_format('" . $beginproductiontime . "','%Y.%m.%d %H:%i:%s'),
							endProductionTime = date_format('" . $endproductiontime . "','%Y.%m.%d %H:%i:%s'),
							pauseProductionTime = date_format('" . $pauseproductiontime . "','%Y.%m.%d %H:%i:%s'),
							lastUpdated = date_format('" . $timestamp . "','%Y.%m.%d %H:%i:%s')
			              	 where jobID = " . $this->jobID_);
        } 

        return $this->jobID_;
    }
}
?>
