<?php

/**
 * Eve-Online API Trawler
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
require_once('includes/class.functions.php');

class Player
{
	function Player($id = 0)
    {
		
        $this->id_ = $id;
        $this->qry_ = new DBQuery();
		
		// check if DB exists, if not - create it
		$this->qry_->execute("CREATE TABLE IF NOT EXISTS `players` (
								`playerID` INT UNSIGNED NOT NULL AUTO_INCREMENT ,
								`name` VARCHAR( 64 ) NOT NULL ,
								`forumGroupID` INT NOT NULL, 
								`created` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
								PRIMARY KEY ( `playerID` ) ,
								INDEX ( `forumGroupID` ) 
								) ENGINE = MYISAM" );
		
    }
	
	function findIDfromName($sname)
    {
		$this->qry_->execute("select * from players
	  	                   where name = '".slashfix($sname)."'");
        $this->row_ = $this->qry_->getRow();
		
        return $this->row_['playerID'];
    }
	
	function getAll($forumGroupID)
    {
		if ($forumGroupID != "ADMIN")
		{
       	 	$this->sql_ = "SELECT * 
						   FROM `players` 
						   WHERE forumGroupID = '" . $forumGroupID . "'
						   ORDER BY `playerID` DESC";
		} else {
			$this->sql_ = "SELECT * 
						   FROM `players` 
						   ORDER BY `playerID` DESC";
		}
        $this->qry_->execute($this->sql_);
		while($player_ = $this->qry_->getRow())
		{
			$array['playerID'] = $player_['playerID'];
			$array['name'] = $player_['name'];
			$array['created'] = $player_['created'];
			
			$playerArray[] = $array;
			unset($array);
		}
		return $playerArray;
    }
	
	function add($name, $forumGroupID, $timestamp)
    {
		if ($forumGroupID == "ADMIN")
			$forumGroupID = 0;
			
        $this->qry_->execute("select * from players
		               where name = '".slashfix($name)."'
					   and forumGroupID = '" . $forumGroupID . "'");

        if ($this->qry_->recordCount() == 0)
        {
            $this->qry_->execute("insert into players (name, forumGroupID, created) values ( '".slashfix($name)."', '" . $forumGroupID . 
							 	 "',date_format('".$timestamp."','%Y.%m.%d %H:%i:%s'))");
            $this->id_ = $this->qry_->getInsertID();
        }
        else
        {
             $this->id_ = -1; // -1 = name already exists
        }

        return $this->id_;
    }
}

?>