<?php

/**
 * Eve-Online API Trawler
 *
 */
require_once('config.php');
require_once('includes/vbulletin.php');
require_once('includes/db.php');
require_once('includes/class.player.php');
require_once('includes/class.accounts.php');

if ($vbAuthed)
{
	// take playername being added or requested
	$myPlayers = new Player();
	if ($_POST["playername"])
	{
			$myP = stripslashes($_POST["playername"]);
			$myPlayer = stripslashes($myP);
			$myPlayerID = $myPlayers->findIDfromName($myPlayer);
	}
			
	// If request to add a new player has been submitted to the page
	if ($_POST["submitaddplayer"])
	{
		// get the new players name and add to the database table 'players'	
		if ($myPlayers->add($myPlayer, $vbGroupID, date("Y-m-d G:i:s")) == -1 )
			$pageresponse = 'Player "' . $myPlayer . '" already exists';
		else
			$pageresponse = 'Player "' . $myPlayer . '" has been added to the database';
	}
	
	// If request to add a new account has been submitted to the page
	$myAccounts = new Accounts($myPlayerID);
	if ($_POST["submitaccount"])
	{
		$myUserID = $_POST["userid"];
		$myAPIKey = $_POST["apikey"];
		
		// get the new account info and add to the database table 'accounts'	
		if ($myAccounts->add($myUserID, $myAPIKey, date("Y-m-d G:i:s")) === false )
			$pageresponse = 'Player "' . $myPlayer . '" UserID: ' . $myUserID . ' has been updated';
		else
			$pageresponse = 'Player "' . $myPlayer . '" UserID: ' . $myUserID . ' has been added to the database';
	}
	
	// prepare page
	// $title is a variable in header.php - so must be defined before header.php is included
	$title = 'EVE API Trawler :: Player - ' . $myPlayer;
	$titlebar = 'EVE API Trawler :: Player - ' . $myPlayer;
	require_once('includes/css.php');
	require_once('includes/header.php');
	$footer = '</body></html>';
	
	// if there's a page response concerning new player added or player exists - print it
	if (isset($pageresponse))
		$page .= '<div align="center">' . $pageresponse . '</div>';
		
	// Add API Key boxes - form sends new key info to same page where it is then added to the DB
	$page .= '<table align="center" border="0" cellpadding="2">';
	$page .= '<form method="post" action="player.php" name="accountform" onsubmit="return CheckAccountInput()">';
	$page .= '<tr><td>User ID:</td><td><input type="text" name="userid" size="28" maxlength="20"></td><td><input type="submit" value="Add" name="addnewkey" onclick="AddAccountClick()"></td></tr>';
	$page .= '<tr><td>API Key:</td><td colspan="2"><input type="text" name="apikey" size="40" maxlength="64"></td></tr>';
	$page .= '<input type="hidden" name="submitaccount" value="false">';
	$page .= '<input type="hidden" name="playername" value="' . $myPlayer . '">';
	$page .= '</form></table>';
	
	if ( isset($myPlayerID) )
	{
		$accountArray = $myAccounts->getPlayerAccounts();
		$accountcount = count($accountArray);
	}
	
	// Create Table for Player details to go in
	$page .= '<form method="post" action="player.php" name="viewform">';
	$page .= '<br><table align="center" border="1" cellpadding="4"><tr><td align="center"><b>UserID</b></td><td align="center"><b>API Key</b></td><td align="center"><b>Created</b></td><td align="center"><b>Last Updated</b></td></tr>';
	
	for ( $loop=0; $loop < $accountcount; $loop++ )
	{
		$page .= '<tr><td align="center">' . $accountArray[$loop]['userID'] . '</td><td>' 
				. $accountArray[$loop]['apiKey'] . '</td><td align="center">'
				. $accountArray[$loop]['created'] . '</td><td align="center">'
				. $accountArray[$loop]['lastupdated'] . '</td></tr>';
	}
	
	// hidden form control used to pass the playername user wishes to view - it's set in the javascript thats called when a view button is clicked
	$page .= '<input type="hidden" name="playername" value="' . $myPlayer . '">';
	$page .= '</table></form>';
	
	// Trawl Button - sends submit to trawl.php along with playerID which is used to trawl through the players accounts
	$page .= '<div align="center">';
	$page .= '<form method="post" action="trawl.php" name="trawlform">';
	$page .= '<input type="hidden" name="playername" value="' . $myPlayer . '">';
	$page .= '<input type="submit" value="Trawl Accounts" name="trawl">';
	$page .= '</form>';
	
	$page .= '<form method="post" action="view.php" name="viewform">';
	$page .= '<input type="hidden" name="playername" value="' . $myPlayer . '">';
	$page .= '<input type="submit" value="View Details" name="view">';
	$page .= '</form>';
	$page .= '</div>';
	// add footer and print page
	$page .= $footer;
	print $page;
} else {
	echo "you are not logged into forum";
}
?>
<SCRIPT TYPE="text/javascript">
<!--
// check that they entered an amount tested, an amount passed,
// and that they didn't pass units than they more than tested

function CheckAccountInput()
{
	var userlen = parseInt(document.accountform.userid.value.length);
	var apilen = parseInt(document.accountform.apikey.value.length);
	var returnval;

	if (userlen != 0 && apilen == 64)
	{
   		returnval = true;
		document.playerform.submitaccount.value = true;
	}
	else
   	{
		if (userlen == 0)
		{
   			alert("You need to enter the UserID");
		} 
		else if (apilen == 0)
		{
			alert("You need to enter the Full API Key");
		}
		else if (apilen != 64)
		{
			alert("API Keys are always 64 characters, try again dumbass");
		}
   		returnval = false;
   	}
	return returnval;
}

function AddAccountClick()
{
	document.playerform.submitaccount.value = "true";
}

// -->
</SCRIPT>
