<?php

/**
 * Eve-Online API Trawler
 *
 */

require_once('config.php');
require_once('includes/vbulletin.php');
require_once('includes/db.php');
require_once('includes/class.itemID.php');
require_once('includes/class.player.php');
require_once('includes/class.assets.php');
require_once('includes/class.accounts.php');
require_once('includes/class.accountbalance.php');
require_once('includes/class.alliances.php');
require_once('includes/class.character.php');
require_once('includes/class.corporation.php');
require_once('includes/class.cachetimers.php');
require_once('includes/class.industryjobs.php');
require_once('includes/class.marketorders.php');
require_once('includes/class.membertracking.php');
require_once('includes/class.reftypes.php');
require_once('includes/class.shareholders.php');
require_once('includes/class.skillintraining.php');
require_once('includes/class.standings.php');
require_once('includes/class.starbaselist.php');
require_once('includes/class.systems.php');
require_once('includes/class.walletjournal.php');
require_once('includes/class.wallettransactions.php');
require_once('includes/class.killlog.php');
require_once('includes/class.skilltree.php');
require_once('includes/class.api.account.php');
require_once('includes/class.api.accountbalance.php');
require_once('includes/class.api.alliances.php');
require_once('includes/class.api.character.php');
require_once('includes/class.api.corporation.php');
require_once('includes/class.api.skilltree.php');
require_once('includes/class.api.assetlist.php');
require_once('includes/class.api.industryjobs.php');
require_once('includes/class.api.marketorders.php');
require_once('includes/class.api.membertracking.php');
require_once('includes/class.api.reftypes.php');
require_once('includes/class.api.shareholders.php');
require_once('includes/class.api.skillintraining.php');
require_once('includes/class.api.standings.php');
require_once('includes/class.api.starbaselist.php');
require_once('includes/class.api.systems.php');
require_once('includes/class.api.walletjournal.php');
require_once('includes/class.api.wallettransactions.php');
require_once('includes/class.api.conquerablestations.php');
require_once('includes/class.api.killlog.php');

// take playername being added or requested
$myPlayers = new Player();
if ($_POST["playername"])
{
		$myP = stripslashes($_POST["playername"]);
		$myPlayer = stripslashes($myP);
		$myPlayerID = $myPlayers->findIDfromName($myPlayer);
} else {
	echo "Error!";
	die; // page has been called incorrectly
}

// prepare page
// $title is a variable in header.php - so must be defined before header.php is included
$title = 'EVE API Trawler :: Trawling - ' . $myPlayer; 
require_once('includes/css.php');
require_once('includes/javascript.php');
require_once('includes/header.php');
trawlflush();
$footer = '</body></html>';

if ($vbAuthed)
{
	// These are array cacheing interfaces to DB, this increases memory use but drastically reduces mySQL calls
	$ApiCache = new ApiCache();
	$ApiCurrent = new ApiCurrent();
	$itemIDDB = new itemIDDB();
	
	// Check and update EVE API Pages - eg, alliances, systems etc...
	
	// prepare Alliances
	echo "updating alliances table ";
	trawlflush();
	$myAlliances = new AlliancesAPI();
	$allianceresult = $myAlliances->fetch();
	echo "- done<br>";
	trawlflush();
	$myAllianceDB = new AlliancesDB();
	
	// prepare Systems
	echo "updating systems table ";
	trawlflush();
	$mySystems = new SystemsAPI();
	$systemresult = $mySystems->fetch();
	echo "- done<br>";
	trawlflush();
	
	// prepare Reftypes
	echo "updating reftypes table ";
	trawlflush();
	$myRefTypes = new RefTypesAPI();
	$refresult = $myRefTypes->fetch();
	echo "- done<br>";
	trawlflush();
	
	// prepare Conquerable Stations List
	echo "updating conquerable stations table ";
	trawlflush();
	$myConquerable = new ConquerableStationsAPI();
	$conqresult = $myConquerable->fetch();
	echo "- done<br>";
	trawlflush();
	
	// Prepare Skill Tree through API
	echo "updating skill tree table ";
	trawlflush();
	$skilltree = new SkillTreeAPI();
	$streeresult = $skilltree->fetch();
	echo "- done<br><br>";
	trawlflush();
	
	$myAccounts = new Accounts($myPlayerID);
	
	$accountArray = $myAccounts->getPlayerAccounts();
	$accountcount = count($accountArray);
	
	// for each account
	foreach ( (array)$accountArray as $Account )
	{
		$myAccount = new AccountAPI($Account['userID'], $Account['apiKey']);
		$myAccountChars = $myAccount->fetch();
		echo "<b>User ID: " . $Account['userID'] . "</b><br>";
		trawlflush();
		
		if ( isset( $myAccount->error_ ) )
		{
			echo "<b>Error:</b> " . $myAccount->error_ . "<br>";
			trawlflush();
		} else {
			// for each character on account
			foreach( (array)$myAccountChars as $details )
			{
				$isDirector = 0;
				echo "<u>Char: " . $details['name'] . " - Corporation: " . $details['corporationName'] . " - Alliance: "
						 . $myAllianceDB->getAllianceName( $details['corporationID'] ) . "</u><br>";
				trawlflush();
			
				// Add corporation and chars in itemID
				itemIDDB::set((integer)$details['corporationID'], (string)$details['corporationName']);
				itemIDDB::set((integer)$details['characterID'], (string)$details['name']);
				
				// Download and process API Character Sheet
				$myCharacter = new CharacterAPI( $Account['userID'], $Account['apiKey'], (integer)$details['characterID'] );
				$result = $myCharacter->fetch();
				
				// print result
				if ( isset( $myCharacter->error_ ) )
				{
					echo "<b>Error:</b> " . $myCharacter->error_ . "<br>";
					trawlflush();
				} else {
					echo " - Character Sheet " . $myCharacter->output_ . "<br>";
					trawlflush();
					
					// calculate attributes after skills and implants
					$charint = $myCharacter->info_['intelligence'] + $myCharacter->info_['intelligenceBonus'];
					$charmem = $myCharacter->info_['memory'] + $myCharacter->info_['memoryBonus'];
					$charcha = $myCharacter->info_['charisma'] + $myCharacter->info_['charismaBonus'];
					$charper = $myCharacter->info_['perception'] + $myCharacter->info_['perceptionBonus'];
					$charwil = $myCharacter->info_['willpower'] + $myCharacter->info_['willpowerBonus'];
					foreach ( (array)$myCharacter->skills_ as $skill)
					{
						// intelligence skills
						if ( ($skill['typeID'] == 3377) || ($skill['typeID'] == 12376) )
							$charint += $skill['level'];
						// memory skills
						if ( ($skill['typeID'] == 3378) || ($skill['typeID'] == 12385) )
							$charmem += $skill['level'];
						// charisma skills
						if ( ($skill['typeID'] == 3376) || ($skill['typeID'] == 12383) )
							$charcha += $skill['level'];
						// perception skills
						if ( ($skill['typeID'] == 3379) || ($skill['typeID'] == 12387) )
							$charper += $skill['level'];
						// willpower skills
						if ( ($skill['typeID'] == 3375) || ($skill['typeID'] == 12386) )
							$charwil += $skill['level'];
					
						// learning bonus
						if ($skill['typeID'] == 3374)
							$learningbonus = ($skill['level'] * 2) / 100;
					
						// Insert Skill into DB
						$mySkill = new SkillTree();
						$result = $mySkill->addCharSkill( (integer)$details['characterID'], $skill['typeID'],
														  $skill['skillpoints'], $skill['level'] );
					}
					// add 1 to learning bonus
					$learningbonus += 1;
					
					// multiply attribs by learning bonus for final result
					$charint *= $learningbonus;
					$charmem *= $learningbonus;
					$charcha *= $learningbonus;
					$charper *= $learningbonus;
					$charwil *= $learningbonus;
			
					// check roles for director
					$corproles = $myCharacter->roles_['corporationRoles'];
					foreach ((array)$corproles as $role)
					{
						if ($role['roleID'] == 1 )
							$isDirector = 1;
					}
			
					// Insert character details into database
					$myCharacterDB = new Character();
					$addChar = $myCharacterDB->add( $myPlayerID,
													$Account['userID'],
													$myCharacter->info_['characterID'], 
													$myCharacter->info_['name'],
													$myCharacter->info_['race'],
													$myCharacter->info_['bloodLine'],
													$myCharacter->info_['gender'],
													$myCharacter->info_['corporationName'],
													$myCharacter->info_['corporationID'],
													$myCharacter->info_['cloneName'],
													$myCharacter->info_['cloneSkillPoints'],
													$myCharacter->info_['balance'],
													$charint, $charmem, $charcha, $charper, $charwil,
													$myCharacter->info_['intelligenceImplant'],
													$myCharacter->info_['memoryImplant'],
													$myCharacter->info_['charismaImplant'],
													$myCharacter->info_['perceptionImplant'],
													$myCharacter->info_['willpowerImplant'],
													$isDirector,
													date("Y-m-d G:i:s") );
				}
				unset($myCharacter);
				unset($myCharacterDB);
				unset($corproles);
				unset($mySkill);
				unset($myAccount);
				unset($myAccountChars);
				
				// Download and process API Character Sheet
				$myCharacterSkill = new SkillInTrainingAPI( $Account['userID'], $Account['apiKey'], (integer)$details['characterID'] );
				$result = $myCharacterSkill->fetch();
				
				// print result
				if ( isset( $myCharacterSkill->error_ ) )
				{
					echo "<b>Error:</b> " . $myCharacterSkill->error_ . "<br>";
					trawlflush();
				} else {
					echo " - Skill In Training " . $myCharacterSkill->output_ . "<br>";
					trawlflush();
					
					// insert each item into Database
					$TrainingSkillDB = new SkillInTrainingDB();
					$addSkill = $TrainingSkillDB->add( (integer)$details['characterID'],
													   (string)$myCharacterSkill->skillinfo_['currentTQTime'], 
													   (string)$myCharacterSkill->skillinfo_['trainingEndTime'], 
													   (string)$myCharacterSkill->skillinfo_['trainingStartTime'], 
													   (integer)$myCharacterSkill->skillinfo_['trainingTypeID'], 
													   (integer)$myCharacterSkill->skillinfo_['trainingStartSP'], 
													   (integer)$myCharacterSkill->skillinfo_['trainingDestinationSP'],
													   (integer)$myCharacterSkill->skillinfo_['trainingToLevel'], 
													   (integer)$myCharacterSkill->skillinfo_['skillInTraining'] );
				}
				
				// Download and process API Assets Sheet
				$myCharAssets = new AssetsListAPI( $Account['userID'], $Account['apiKey'], (integer)$details['characterID'] );
				$myCharAssets->fetch();
			
				// print result
				if (isset($myCharAssets->error_))
				{
					echo "<b>Error:</b> " . $myCharAssets->error_ . "<br>";
					trawlflush();
				} else {
					echo " - Assets Sheet " . $myCharAssets->output_ . "<br>";
					trawlflush();
					$myAssets = $myCharAssets->assets_;
			
					// insert each item into Database
					$myAssetDB = new Assets();
					$myAssetDB->purge((integer)$details['characterID']);
					foreach ((array)$myAssets as $item)
					{
						$addItem = $myAssetDB->add( $myPlayerID,
												$Account['userID'],
												(integer)$details['characterID'], 
												(integer)$item['container'],
												(integer)$item['itemID'],
												(integer)$item['locationID'],
												(integer)$item['typeID'],
												(integer)$item['quantity'],
												(integer)$item['flag'],
												(integer)$item['singleton'],
												date("Y-m-d G:i:s") );
												
						// add ID's that may need resolving to the array
						itemIDDB::set((integer)$item['locationID'], NULL);
						itemIDDB::set((integer)$item['typeID'], NULL);
					}
				}
				unset($myCharAssets);
				unset($myAssets);
				unset($myAssetDB);
			
				// Download and process API Industry Jobs Sheet
				$myCharIndustryJobs = new IndustryJobsAPI( $Account['userID'], $Account['apiKey'], (integer)$details['characterID'] );
				$myCharIndustryJobs->fetch();
				
				// print result
				if (isset($myCharIndustryJobs->error_))
				{
					echo "<b>Error:</b> " . $myCharIndustryJobs->error_ . "<br>";
					trawlflush();
				} else {
					echo " - Industry Jobs Sheet " . $myCharIndustryJobs->output_ . "<br>";
					trawlflush();
				
					$myIndustryJobs = $myCharIndustryJobs->jobs_;
			
					// insert each item into Database
					$myIndustryDB = new IndustryJobsDB();
					foreach ((array)$myIndustryJobs as $job)
					{
						$addJob = $myIndustryDB->add( $myPlayerID,
												$Account['userID'],
												(integer)$details['characterID'], 
												(integer)$job['jobID'],
												(integer)$job['assemblyLineID'],
												(integer)$job['containerID'],
												(integer)$job['installedItemID'],
												(integer)$job['installedItemLocationID'],
												(integer)$job['installedItemQuantity'],
												(integer)$job['installedItemProductivityLevel'],
												(integer)$job['installedItemMaterialLevel'],
												(integer)$job['installedItemLicensedProductionRunsRemaining'],
												(integer)$job['outputLocationID'],
												(integer)$job['installerID'],
												(integer)$job['runs'],
												(integer)$job['licensedProductionRuns'],
												(integer)$job['installedInSolarSystemID'],
												(integer)$job['containerLocationID'],
												(float)$job['materialMultiplier'],
												(float)$job['charMaterialMultiplier'],
												(float)$job['timeMultiplier'],
												(float)$job['charTimeMultiplier'],
												(integer)$job['installedItemTypeID'],
												(integer)$job['outputTypeID'],
												(integer)$job['containerTypeID'],
												(integer)$job['installedItemCopy'],
												(integer)$job['completed'],
												(integer)$job['completedSuccessfully'],
												(integer)$job['installedItemFlag'],
												(integer)$job['outputFlag'],
												(integer)$job['activityID'],
												(integer)$job['completedStatus'],
												(string)$job['installTime'],
												(string)$job['beginProductionTime'],
												(string)$job['endProductionTime'],
												(string)$job['pauseProductionTime'],
												date("Y-m-d G:i:s") );
												
						// add ID's that may need resolving to the array
						itemIDDB::set((integer)$job['containerID'], NULL);
						itemIDDB::set((integer)$job['installedItemLocationID'], NULL);
						itemIDDB::set((integer)$job['outputLocationID'], NULL);
						itemIDDB::set((integer)$job['installerID'], NULL);
						itemIDDB::set((integer)$job['installedInSolarSystemID'], NULL);
						itemIDDB::set((integer)$job['containerLocationID'], NULL);
						itemIDDB::set((integer)$job['installedItemTypeID'], NULL);
						itemIDDB::set((integer)$job['outputTypeID'], NULL);
						itemIDDB::set((integer)$job['containerTypeID'], NULL);
					}
				} 
				
				// Download and process API KillLog Sheet
				$myCharKillLog = new KillLogAPI( $Account['userID'], $Account['apiKey'], (integer)$details['characterID'] );
				$myCharKillLog->fetch();
				
				// print result
				if (isset($myCharKillLog->error_))
				{
					echo "<b>Error:</b> " . $myCharKillLog->error_ . "<br>";
					trawlflush();
				} else {
					echo " - Kill Log Sheet " . $myCharKillLog->output_ . "<br>";
					trawlflush();
				
					$myKillLogList = $myCharKillLog->killlog_;
					
					// insert each item into Database
					$myKillLogDB = new KillLogDB();
					foreach ((array)$myKillLogList as $killmail)
					{
						$addKill = $myKillLogDB->add( $myPlayerID,
												$Account['userID'],
												(integer)$details['characterID'], 
												(string)$killmail['killTime'],
												(integer)$killmail['killID'],
												(integer)$killmail['solarSystemID'],
												(string)$killmail['characterName'],
												(integer)$killmail['characterID'],
												(string)$killmail['corporationName'],
												(integer)$killmail['corporationID'],
												(string)$killmail['allianceName'],
												(integer)$killmail['shipTypeID'],
												(integer)$killmail['aggressors'],
												date("Y-m-d G:i:s") );
												
						// add ID's that may need resolving to the array
						itemIDDB::set((integer)$killmail['shipTypeID'], NULL);
						itemIDDB::set((integer)$killmail['characterID'], (string)$killmail['characterName']);
						itemIDDB::set((integer)$killmail['corporationID'], (string)$killmail['corporationName']);
					}
				}
			
				// Download and process API Market Orders Sheet
				$myCharMarketOrders = new MarketOrdersAPI( $Account['userID'], $Account['apiKey'], (integer)$details['characterID'] );
				$myCharMarketOrders->fetch();
			
				// print result
				if (isset($myCharMarketOrders->error_))
				{
					echo "<b>Error:</b> " . $myCharMarketOrders->error_ . "<br>";
					trawlflush();
				} else {
					echo " - Market Orders Sheet " . $myCharMarketOrders->output_ . "<br>";
					trawlflush();
				
					$myMarketOrders = $myCharMarketOrders->orders_;
	
					// insert each item into Database
					$myMarketDB = new MarketOrdersDB();
					foreach ((array)$myMarketOrders as $order)
					{
						$addJob = $myMarketDB->add( $myPlayerID,
												$Account['userID'],
												(integer)$details['characterID'], 
												(integer)$order['orderID'],
												(integer)$order['charID'],
												(integer)$order['stationID'],
												(integer)$order['volEntered'],
												(integer)$order['volRemaining'],
												(integer)$order['minVolume'],
												(integer)$order['orderState'],
												(integer)$order['typeID'],
												(integer)$order['range'],
												(integer)$order['accountKey'],
												(integer)$order['duration'],
												(string)$order['escrow'],
												(string)$order['price'],
												(integer)$order['bid'],
												(string)$order['issued'],
												date("Y-m-d G:i:s") );
												
						// add ID's that may need resolving to the array
						itemIDDB::set((integer)$order['stationID'], NULL);
						itemIDDB::set((integer)$order['typeID'], NULL);
					}
				}
			
				// Download and process API Wallet Journal Sheet
				$myCharWalletJournal = new WalletJournalAPI( $Account['userID'], $Account['apiKey'], (integer)$details['characterID'] );
				$myCharWalletJournal->fetch();
			
				// print result
				if (isset($myCharWalletJournal->error_))
				{
					echo "<b>Error:</b> " . $myCharWalletJournal->error_ . "<br>";
					trawlflush();
				} else {
					echo " - Wallet Journal Sheet " . $myCharWalletJournal->output_ . "<br>";
					trawlflush();
	
					$myWalletTransactions = $myCharWalletJournal->entry_;
			
					// insert each item into Database
					$myJournalDB = new WalletJournalDB();
					foreach ((array)$myWalletTransactions as $entry)
					{
						$addJob = $myJournalDB->add( $myPlayerID,
												$Account['userID'],
												(integer)$details['characterID'], 
												1000,
												(string)$entry['date'],
												(integer)$entry['refID'],
												(integer)$entry['refTypeID'],
												(string)$entry['ownerName1'],
												(integer)$entry['ownerID1'],
												(string)$entry['ownerName2'],
												(integer)$entry['ownerID2'],
												(string)$entry['argName1'],
												(integer)$entry['argID1'],
												(string)$entry['amount'],
												(string)$entry['balance'],
												(string)$entry['reason'],
												date("Y-m-d G:i:s") );
												
						// add ID's that may need resolving to the array
						itemIDDB::set((integer)$entry['ownerID1'], (string)$entry['ownerName1']);
						if ( ((integer)$entry['refTypeID'] != 8) && ((integer)$entry['refTypeID'] != 42) )
							itemIDDB::set((integer)$entry['ownerID2'], (string)$entry['ownerName2']);
						//if ((integer)$entry['argID1'] != 0)
						//	itemIDDB::set((integer)$entry['argID1'], (string)$entry['argName1']);
					}
				}
				
				// Download and process API Wallet Transactions Sheet
				$myCharWalletTransactions = new WalletTransactionsAPI( $Account['userID'], $Account['apiKey'], 
																		(integer)$details['characterID'] );
				$myCharWalletTransactions->fetch();
			
				// print result
				if (isset($myCharWalletTransactions->error_))
				{
					echo "<b>Error:</b> " . $myCharWalletTransactions->error_ . "<br>";
					trawlflush();
				} else {
					echo " - Wallet Transactions Sheet " . $myCharWalletTransactions->output_ . "<br>";
					trawlflush();
	
					$myWalletTransactions = $myCharWalletTransactions->transaction_;
			
					// insert each item into Database
					$myTransactionsDB = new WalletTransactionsDB();
					foreach ((array)$myWalletTransactions as $transaction)
					{
						$addJob = $myTransactionsDB->add( $myPlayerID,
												$Account['userID'],
												(integer)$details['characterID'], 
												1000,
												(string)$transaction['transactionDateTime'],
												(integer)$transaction['transactionID'],
												(integer)$transaction['quantity'],
												(string)$transaction['typeName'],
												(integer)$transaction['typeID'],
												(string)$transaction['price'],
												(integer)$transaction['clientID'],
												(string)$transaction['clientName'],
												(integer)$transaction['stationID'],
												(string)$transaction['stationName'],
												(string)$transaction['transactionType'],
												(string)$transaction['transactionFor'],
												date("Y-m-d G:i:s") );
												
						// add ID's that may need resolving to the array
						itemIDDB::set((integer)$transaction['clientID'], (string)$transaction['clientName']);
						itemIDDB::set((integer)$transaction['stationID'], (string)$transaction['stationName']);
						itemIDDB::set((integer)$transaction['typeID'], (string)$transaction['typeName']);
					}
				}
				
				// Download and process API Standings Sheet
				$myCharStandings = new StandingsAPI( $Account['userID'], $Account['apiKey'], 
																		(integer)$details['characterID'] );
				$myStandings = $myCharStandings->fetch();
			
				// print result
				if (isset($myCharStandings->error_))
				{
					echo "<b>Error:</b> " . $myCharStandings->error_ . "<br>";
					trawlflush();
				} else {
					echo " - Character Standings Sheet " . $myCharStandings->output_ . "<br>";
					trawlflush();
					
					// insert each item into Database
					$myStandingsDB = new StandingsDB();
					$myStandingsDB->purge((integer)$details['characterID']);
					foreach ((array)$myStandings as $standing)
					{
						$addstanding = $myStandingsDB->add( 
												(integer)$details['characterID'],
												(string)$standing['type'],
												(string)$standing['subtype'],
												(integer)$standing['toID'],
												(string)$standing['toName'],
												(string)$standing['standing'] );
												
						// add ID's that may need resolving to the array
						itemIDDB::set((integer)$standing['toID'], (string)$standing['toName']);
					}
				}
				
				// check if corp has been trawled before
				$trawlcheck = false;
				foreach ((array)$trawledcorps as $trawlc)
				{
					if ($trawlc == (string)$details['corporationName'])
						$trawlcheck = true;
				}
				// Collect Corporation information for this character if it is Director/Ceo
				if ( ($isDirector == 1) && (!$trawlcheck) )
				{ 
					// add to array of trawled corps to avoid trawling it again
					$trawledcorps[] = (string)$details['corporationName'];
					
					// display corporation
					echo "<u>Corporation: " . $details['corporationName'] . "</u><br>";
					trawlflush();
					
					// Download and process API Corporation Sheet
					$myCorpSheet = new CorporationAPI( $Account['userID'], $Account['apiKey'], (integer)$details['characterID'],
													   (integer)$details['corporationID'] );
					$myCorpSheet->fetch();
			
					// print result
					if (isset($myCorpSheet->error_))
					{
						echo "<b>Error:</b> " . $myCorpSheet->error_ . "<br>";
						trawlflush();
					} else {
						echo " - Corporation Sheet " . $myCorpSheet->output_ . "<br>";
						trawlflush();
						
						$myCorpDivisions = $myCorpSheet->divisions_;
						$myWalletDivisions = $myCorpSheet->walletDivisions_;
						
						$divcounter = 0;
						foreach ((array)$myCorpDivisions as $division)
						{
							$divcounter++;
							$div[$divcounter] = $division['description'];
						}
						$divcounter = 0;
						foreach ((array)$myWalletDivisions as $division)
						{
							$divcounter++;
							$wal[$divcounter] = $division['description'];
						}
						// insert each item into Database
						$myCorpDB = new CorporationDB();
						//$myAssetDB->purge((integer)$details['characterID']);
						
						$addItem = $myCorpDB->add( (integer)$myCorpSheet->info_['corporationID'],
												(string)$myCorpSheet->info_['corporationName'],
												(string)$myCorpSheet->info_['ticker'], 
												(integer)$myCorpSheet->info_['ceoID'],
												(string)$myCorpSheet->info_['ceoName'],
												(integer)$myCorpSheet->info_['stationID'],
												(string)$myCorpSheet->info_['stationName'],
												(string)$myCorpSheet->info_['description'],
												(string)$myCorpSheet->info_['url'],
												(integer)$myCorpSheet->info_['allianceID'],
												(string)$myCorpSheet->info_['allianceName'],
												(string)$myCorpSheet->info_['taxRate'],
												(integer)$myCorpSheet->info_['memberCount'],
												(integer)$myCorpSheet->info_['memberLimit'],
												(integer)$myCorpSheet->info_['shares'],
												(string)$div[1],
												(string)$div[2],
												(string)$div[3],
												(string)$div[4],
												(string)$div[5],
												(string)$div[6],
												(string)$div[7],
												(string)$wal[1],
												(string)$wal[2],
												(string)$wal[3],
												(string)$wal[4],
												(string)$wal[5],
												(string)$wal[6],
												(string)$wal[7],
												date("Y-m-d G:i:s") );
												
							// add ID's that may need resolving to the array
						
					}
					unset($myCorpSheet);
					unset($myCorpDivisions);
					unset($myWalletDivisions);
					unset($myCorpDB);
					
					// Download and process API Assets Sheet
					$myCorpAssets = new AssetsListAPI( $Account['userID'], $Account['apiKey'], (integer)$details['characterID'], (integer)$details['corporationID'] );
					$myCorpAssets->fetch();
			
					// print result
					if (isset($myCorpAssets->error_))
					{
						echo "<b>Error:</b> " . $myCorpAssets->error_ . "<br>";
						trawlflush();
					} else {
						echo " - Corporation Assets Sheet " . $myCorpAssets->output_ . "<br>";
						trawlflush();
						$myAssets = $myCorpAssets->assets_;
			
						// insert each item into Database
						$myCorpAssetDB = new Assets();
						$myCorpAssetDB->purge((integer)$details['corporationID']);
						foreach ((array)$myAssets as $item)
						{
							$addItem = $myCorpAssetDB->add( $myPlayerID,
													$Account['userID'],
													(integer)$details['corporationID'], 
													(integer)$item['container'],
													(integer)$item['itemID'],
													(integer)$item['locationID'],
													(integer)$item['typeID'],
													(integer)$item['quantity'],
													(integer)$item['flag'],
													(integer)$item['singleton'],
													date("Y-m-d G:i:s") );
													
							// add ID's that may need resolving to the array
							itemIDDB::set((integer)$item['locationID'], NULL);
							itemIDDB::set((integer)$item['typeID'], NULL);
						}
					}
				
					// Download and process API Corp Balances
					$myCorpAccountBalances = new AccountBalanceAPI( $Account['userID'], $Account['apiKey'], 
																(integer)$details['characterID'], (integer)$details['corporationID'] );
					$myCorpAccountBalances->fetch();
				
					// print result
					if (isset($myCorpAccountBalances->error_))
					{
						echo "<b>Error:</b> " . $myCorpAccountBalances->error_ . "<br>";
						trawlflush();
					} else { 
						echo " - Corporation Account Balances Sheet " . $myCorpAccountBalances->output_ . "<br>";
						trawlflush();
						
						$myCorpAccountBalancesList = $myCorpAccountBalances->balances_;
						
						// insert each item into Database
						$myAccountBalanceDB = new AccountBalanceDB();
						foreach ((array)$myCorpAccountBalancesList as $balance)
						{
							$addBalance = $myAccountBalanceDB->add( (integer)$details['corporationID'], 
												(integer)$balance['accountID'],
												(integer)$balance['accountKey'],
												(string)$balance['balance'] );
						}
					}
																			
					// Download and process API Industry Jobs Sheet
					$myCorpIndustryJobs = new IndustryJobsAPI( $Account['userID'], $Account['apiKey'], 
																(integer)$details['characterID'], (integer)$details['corporationID'] );
					$myCorpIndustryJobs->fetch();
				
					// print result
					if (isset($myCorpIndustryJobs->error_))
					{
						echo "<b>Error:</b> " . $myCorpIndustryJobs->error_ . "<br>";
						trawlflush();
					} else { 
						echo " - Corporation Industry Jobs Sheet " . $myCorpIndustryJobs->output_ . "<br>";
						trawlflush();
					
						$myCorpIndustryJobsList = $myCorpIndustryJobs->jobs_;
			
						// insert each item into Database
						$myIndustryDB = new IndustryJobsDB();
						foreach ((array)$myCorpIndustryJobsList as $job)
						{
							$addJob = $myIndustryDB->add( $myPlayerID,
												$Account['userID'],
												(integer)$details['corporationID'], 
												(integer)$job['jobID'],
												(integer)$job['assemblyLineID'],
												(integer)$job['containerID'],
												(integer)$job['installedItemID'],
												(integer)$job['installedItemLocationID'],
												(integer)$job['installedItemQuantity'],
												(integer)$job['installedItemProductivityLevel'],
												(integer)$job['installedItemMaterialLevel'],
												(integer)$job['installedItemLicensedProductionRunsRemaining'],
												(integer)$job['outputLocationID'],
												(integer)$job['installerID'],
												(integer)$job['runs'],
												(integer)$job['licensedProductionRuns'],
												(integer)$job['installedInSolarSystemID'],
												(integer)$job['containerLocationID'],
												(float)$job['materialMultiplier'],
												(float)$job['charMaterialMultiplier'],
												(float)$job['timeMultiplier'],
												(float)$job['charTimeMultiplier'],
												(integer)$job['installedItemTypeID'],
												(integer)$job['outputTypeID'],
												(integer)$job['containerTypeID'],
												(integer)$job['installedItemCopy'],
												(integer)$job['completed'],
												(integer)$job['completedSuccessfully'],
												(integer)$job['installedItemFlag'],
												(integer)$job['outputFlag'],
												(integer)$job['activityID'],
												(integer)$job['completedStatus'],
												(string)$job['installTime'],
												(string)$job['beginProductionTime'],
												(string)$job['endProductionTime'],
												(string)$job['pauseProductionTime'],
												date("Y-m-d G:i:s") );
												
							// add ID's that may need resolving to the array
							itemIDDB::set((integer)$job['containerID'], NULL);
							itemIDDB::set((integer)$job['installedItemLocationID'], NULL);
							itemIDDB::set((integer)$job['outputLocationID'], NULL);
							itemIDDB::set((integer)$job['installerID'], NULL);
							itemIDDB::set((integer)$job['installedInSolarSystemID'], NULL);
							itemIDDB::set((integer)$job['containerLocationID'], NULL);
							itemIDDB::set((integer)$job['installedItemTypeID'], NULL);
							itemIDDB::set((integer)$job['outputTypeID'], NULL);
							itemIDDB::set((integer)$job['containerTypeID'], NULL);
						}
					} 
				
					// Download and process API KillLog Sheet
					$myCorpKillLog = new KillLogAPI( $Account['userID'], $Account['apiKey'],
																 (integer)$details['characterID'], (integer)$details['corporationID'] );
					$myCorpKillLog->fetch();
			
					// print result
					if (isset($myCorpKillLog->error_))
					{
						echo "<b>Error:</b> " . $myCorpKillLog->error_ . "<br>";
						trawlflush();
					} else { 
						echo " - Corporation Kill Log Sheet " . $myCorpKillLog->output_ . "<br>";
						trawlflush();
					
						$myCorpKillMails = $myCorpKillLog->killlog_;
	
						// insert each item into Database
						$myCorpKillLogDB = new KillLogDB();
						foreach ((array)$myCorpKillMails as $corpkillmail)
						{
							$addKill = $myCorpKillLogDB->add( $myPlayerID,
												$Account['userID'],
												(integer)$details['corporationID'], 
												(string)$corpkillmail['killTime'],
												(integer)$corpkillmail['killID'],
												(integer)$corpkillmail['solarSystemID'],
												(string)$corpkillmail['characterName'],
												(integer)$corpkillmail['characterID'],
												(string)$corpkillmail['corporationName'],
												(integer)$corpkillmail['corporationID'],
												(string)$corpkillmail['allianceName'],
												(integer)$corpkillmail['shipTypeID'],
												(integer)$corpkillmail['aggressors'],
												date("Y-m-d G:i:s") );
												
							// add ID's that may need resolving to the array
							itemIDDB::set((integer)$corpkillmail['shipTypeID'], NULL);
							itemIDDB::set((integer)$corpkillmail['characterID'], (string)$corpkillmail['characterName']);
							itemIDDB::set((integer)$corpkillmail['corporationID'], (string)$corpkillmail['corporationName']);
						}
					}
				
					// Download and process API Market Orders Sheet
					$myCorpMarketOrders = new MarketOrdersAPI( $Account['userID'], $Account['apiKey'],
																 (integer)$details['characterID'], (integer)$details['corporationID'] );
					$myCorpMarketOrders->fetch();
			
					// print result
					if (isset($myCorpMarketOrders->error_))
					{
						echo "<b>Error:</b> " . $myCorpMarketOrders->error_ . "<br>";
						trawlflush();
					} else { 
						echo " - Corporation Market Orders Sheet " . $myCorpMarketOrders->output_ . "<br>";
						trawlflush();
					
						$myMarketOrders = $myCorpMarketOrders->orders_;
	
						// insert each item into Database
						$myMarketDB = new MarketOrdersDB();
						foreach ((array)$myMarketOrders as $order)
						{
							$addJob = $myMarketDB->add( $myPlayerID,
												$Account['userID'],
												(integer)$details['corporationID'], 
												(integer)$order['orderID'],
												(integer)$order['charID'],
												(integer)$order['stationID'],
												(integer)$order['volEntered'],
												(integer)$order['volRemaining'],
												(integer)$order['minVolume'],
												(integer)$order['orderState'],
												(integer)$order['typeID'],
												(integer)$order['range'],
												(integer)$order['accountKey'],
												(integer)$order['duration'],
												(string)$order['escrow'],
												(string)$order['price'],
												(integer)$order['bid'],
												(string)$order['issued'],
												date("Y-m-d G:i:s") );
												
							// add ID's that may need resolving to the array
							itemIDDB::set((integer)$order['stationID'], NULL);
							itemIDDB::set((integer)$order['typeID'], NULL);
						}
					}
			
					// Download and process API Wallet Journal Sheet
					for ($key=1000;$key<1007;$key++)
					{
						$myCorpWalletJournal = new WalletJournalAPI( $Account['userID'], $Account['apiKey'], 
																(integer)$details['characterID'], $key, (integer)$details['corporationID'] );
						$myCorpWalletJournal->fetch();
			
						// print result
						if (isset($myCorpWalletJournal->error_))
						{
							echo "<b>Error:</b> " . $myCorpWalletJournal->error_ . "<br>";
							trawlflush();
						} else { 
							echo " - Corporation Wallet " . ($key-999) . " Journal Sheet " . $myCorpWalletJournal->output_ . "<br>";
							trawlflush();
	
							$myWalletTransactions = $myCorpWalletJournal->entry_;
			
							// insert each item into Database
							$myJournalDB = new WalletJournalDB();
							foreach ((array)$myWalletTransactions as $entry)
							{
								$addJob = $myJournalDB->add( $myPlayerID,
												$Account['userID'],
												(integer)$details['corporationID'], 
												(integer)$key,
												(string)$entry['date'],
												(integer)$entry['refID'],
												(integer)$entry['refTypeID'],
												(string)$entry['ownerName1'],
												(integer)$entry['ownerID1'],
												(string)$entry['ownerName2'],
												(integer)$entry['ownerID2'],
												(string)$entry['argName1'],
												(integer)$entry['argID1'],
												(string)$entry['amount'],
												(string)$entry['balance'],
												(string)$entry['reason'],
												date("Y-m-d G:i:s") );
												
								// add ID's that may need resolving to the array
								itemIDDB::set((integer)$entry['ownerID1'], (string)$entry['ownerName1']);
								if ( ((integer)$entry['refTypeID'] != 8) && ((integer)$entry['refTypeID'] != 42) )
									itemIDDB::set((integer)$entry['ownerID2'], (string)$entry['ownerName2']);
								//if ((integer)$entry['argID1'] != 0)
								//	itemIDDB::set((integer)$entry['argID1'], (string)$entry['argName1']);
							}
						}
					}
				
					// Download and process API Wallet Transactions Sheet
					for ($key=1000; $key<1007; $key++)
					{
						$myCorpWalletTransactions = new WalletTransactionsAPI( $Account['userID'], $Account['apiKey'],
																 (integer)$details['characterID'], $key, (integer)$details['corporationID'] );
						$myCorpWalletTransactions->fetch();
			
						// print result
						if (isset($myCorpWalletTransactions->error_))
						{
							echo "<b>Error:</b> " . $myCorpWalletTransactions->error_ . "<br>";
							trawlflush();
						} else { 
							echo " - Corporation Wallet " . ($key-999) . " Transactions Sheet " . $myCorpWalletJournal->output_ . "<br>";
							trawlflush();
							
							$myWalletTransactions = $myCorpWalletTransactions->transaction_;
			
							// insert each item into Database
							$myTransactionsDB = new WalletTransactionsDB();
							foreach ((array)$myWalletTransactions as $transaction)
							{
								$addJob = $myTransactionsDB->add( $myPlayerID,
												$Account['userID'],
												(integer)$details['corporationID'], 
												(integer)$key,
												(string)$transaction['transactionDateTime'],
												(integer)$transaction['transactionID'],
												(integer)$transaction['quantity'],
												(string)$transaction['typeName'],
												(integer)$transaction['typeID'],
												(string)$transaction['price'],
												(integer)$transaction['clientID'],
												(string)$transaction['clientName'],
												(integer)$transaction['stationID'],
												(string)$transaction['stationName'],
												(string)$transaction['transactionType'],
												(string)$transaction['transactionFor'],
												date("Y-m-d G:i:s") );
												
								// add ID's that may need resolving to the array
								itemIDDB::set((integer)$transaction['clientID'], (string)$transaction['clientName']);
								itemIDDB::set((integer)$transaction['stationID'], (string)$transaction['stationName']);
								itemIDDB::set((integer)$transaction['typeID'], (string)$transaction['typeName']);
							}
						}
					} 
					
					// Download and process API Starbase List (ignore starbase Detail)
					$myStarbaseList = new StarbaseListAPI( $Account['userID'], $Account['apiKey'], (integer)$details['characterID'], 
															(integer)$details['corporationID'] );
					$myStarbaseList->fetch();
					
					// print result
					if (isset($myStarbaseList->error_))
					{
						echo "<b>Error:</b> " . $myStarbaseList->error_ . "<br>";
						trawlflush();
					} else {
						echo " - Corporation Starbase List Sheet " . $myStarbaseList->output_ . "<br>";
						trawlflush();
						
						$myBases = $myStarbaseList->starbases_;
			
						// insert each item into Database
						$myStarbaseDB = new StarbaseListDB();
						$myStarbaseDB->purge((integer)$details['corporationID']);
						foreach ((array)$myBases as $base)
						{
							$addBase = $myStarbaseDB->add( 
													(integer)$details['corporationID'],
													(integer)$base['itemID'],
													(integer)$base['typeID'], 
													(integer)$base['locationID'],
													(integer)$base['moonID'],
													(integer)$base['state'],
													(string)$base['stateTimestamp'],
													(string)$base['onlineTimestamp'] );
													
							// add ID's that may need resolving to the array
							itemIDDB::set((integer)$base['typeID'], NULL);
							itemIDDB::set((integer)$base['moonID'], NULL);
						}
					} 
					
					// Download and process API Member Tracking
					$myMembersAPI = new MemberTrackingAPI( $Account['userID'], $Account['apiKey'], (integer)$details['characterID'],
															(integer)$details['corporationID'] );
					$myMembersAPI->fetch();
					
					// print result
					if (isset($myMembersAPI->error_))
					{
						echo "<b>Error:</b> " . $myMembersAPI->error_ . "<br>";
						trawlflush();
					} else {
						echo " - Corporation Member Tracking Sheet " . $myMembersAPI->output_ . "<br>";
						trawlflush();
						
						$myMembers = $myMembersAPI->member_;
			
						// insert each item into Database
						$myMembersDB = new MemberTrackingDB();
						$myMembersDB->purge((integer)$details['corporationID']);
						foreach ((array)$myMembers as $member)
						{
							$addBase = $myMembersDB->add( 
													(integer)$details['corporationID'],
													(integer)$member['characterID'],
													(string)$member['name'],
													(string)$member['startDateTime'], 
													(integer)$member['baseID'],
													(string)$member['base'],
													(string)$member['title'],
													(string)$member['logonDateTime'],
													(string)$member['logoffDateTime'],
													(integer)$member['locationID'],
													(string)$member['location'],
													(integer)$member['shipTypeID'],
													(string)$member['shipType'],
													(integer)$member['roles'],
													(integer)$member['grantableRoles'] );
													
							// add ID's that may need resolving to the array
							itemIDDB::set((integer)$member['characterID'], (string)$member['name']);
							itemIDDB::set((integer)$member['locationID'], (string)$member['location']);
							itemIDDB::set((integer)$member['shipTypeID'], (string)$member['shipType']);
						}
					}
					
					// Download and process API Shareholders
					$mySharesAPI = new ShareholdersAPI( $Account['userID'], $Account['apiKey'], (integer)$details['characterID'],
															(integer)$details['corporationID'] );
					$myShares = $mySharesAPI->fetch();
					
					// print result
					if (isset($mySharesAPI->error_))
					{
						echo "<b>Error:</b> " . $mySharesAPI->error_ . "<br>";
						trawlflush();
					} else {
						echo " - Corporation Shareholders Sheet " . $mySharesAPI->output_ . "<br>";
						trawlflush();
			
						// insert each item into Database
						$mySharesDB = new ShareholdersDB();
						$mySharesDB->purge((integer)$details['corporationID']);
						foreach ((array)$myShares as $shareholder)
						{
							$addShare = $mySharesDB->add( 
													(integer)$details['corporationID'],
													(integer)$shareholder['isCorp'],
													(integer)$shareholder['shareholderID'],
													(string)$shareholder['shareholderName'], 
													(integer)$shareholder['shareholderCorporationID'],
													(string)$shareholder['shareholderCorporationName'],
													(integer)$shareholder['shares'] );
													
							// add ID's that may need resolving to the array
							itemIDDB::set((integer)$shareholder['shareholderID'], (string)$shareholder['shareholderName']);
							itemIDDB::set((integer)$shareholder['shareholderCorporationID'], (string)$shareholder['shareholderCorporationName']);
						}
					}
					
					// Download and process API Standings
					// Download and process API Standings Sheet
					$myCorpStandings = new StandingsAPI( $Account['userID'], $Account['apiKey'], (integer)$details['characterID'], 
														 (integer)$details['corporationID'] );
					$corpStandings = $myCorpStandings->fetch();
				
					// print result
					if (isset($myCorpStandings->error_))
					{
						echo "<b>Error:</b> " . $myCorpStandings->error_ . "<br>";
						trawlflush();
					} else {
						echo " - Corporation Standings Sheet " . $myCorpStandings->output_ . "<br>";
						trawlflush();
						
						// insert each item into Database
						$myStandingsDB = new StandingsDB();
						$myStandingsDB->purge((integer)$details['corporationID']);
						foreach ((array)$corpStandings as $standing)
						{
							$addstanding = $myStandingsDB->add( 
													(integer)$details['corporationID'],
													(string)$standing['type'],
													(string)$standing['subtype'],
													(integer)$standing['toID'],
													(string)$standing['toName'],
													(string)$standing['standing'] );
													
							// add ID's that may need resolving to the array
							itemIDDB::set((integer)$standing['toID'], (string)$standing['toName']);
						}
					}
				
					// ignoring medals, membermedals, container logs, member security, member security logs and titles
				
				} else {
					if ($trawlcheck)
					{
						echo "<u>Corporation: " . $details['corporationName'] . "</u><br>";
						echo " - <i>This corp has already been trawled</i><br>";
						trawlflush();
					}
				}
			}
		}
		echo "<br>";
		trawlflush();
	}
	
	// resolve any ID's that are set to NULL - don't call this if Account failed to trawl (eg, if website is down - any NULLs in itemDB will go into an endless loop, which is bad
	if ( !isset( $myAccount->error_ ) )
	{
		echo "resolving itemID values";
		echo itemIDDB::resolvevalues() . "<br>";
		trawlflush();
	}
	// add footer and print page
	echo '<form method="post" action="view.php" name="viewform">';
	echo '<div><input type="submit" value="View" name="viewplayer" id="' . slashfix($myPlayer) . '" onclick="return ViewPlayer(this)"></div>';
	echo '<input type="hidden" name="playername">';
	echo '</form>';
	echo $footer;
	
} else {
	// Not authed to be looking at this page
	echo "you are not logged into forum";
}
trawlflush();
?>
<SCRIPT TYPE="text/javascript">
<!--
function ViewPlayer(obj)
{
	var playername = obj.id;
	var returnval = true;

	document.viewform.playername.value = playername;

	return returnval;
}
// -->
</SCRIPT>
