<?php

/**
 * Eve-Online API Trawler
 *
 * Warning: This file could well be the biggest pile of shit you will ever see, however, whether through 
 * luck or a pact with Satan, it works.
 */

require_once('config.php');
require_once('includes/vbulletin.php');
require_once('includes/db.php');
require_once('includes/class.analysis.php');
require_once('includes/class.itemID.php');
require_once('includes/class.player.php');
require_once('includes/class.cachetimers.php');

if ($vbAuthed)
{
	// take playername being added or requested
	// needs to have multiple stripslashes for players than have special characters in name - eg, k'lunk
	$myPlayers = new Player();
	if ($_POST["playername"]) {
		// post is sent from form on player.php page
		$myP = stripslashes($_POST["playername"]);
	} else {
		echo "Error!";
		die; // page has been called incorrectly
	}
	$myPlayer = stripslashes($myP);
	$myPlayerID = $myPlayers->findIDfromName($myPlayer);
	
	// These are array cacheing interfaces to DB, this increases memory use but drastically reduces mySQL calls
	$ApiCache = new ApiCache();
	$ApiCurrent = new ApiCurrent();
	$itemIDDB = new itemIDDB();
	
	$myAnalysis = new Analysis($myPlayerID);
	
	$accountArray = $myAnalysis->getPlayerAccounts();
	$accountcount = $myAnalysis->getNumAccounts();
	
	// Create the arrays used in the JavaScript code - it is dynamic as it depends on Number of Accounts and Characters/Corps
	// Unless the tabbing system is being changed this and the following JS really shouldn't need to be changed
	$counter = 0;
	$counter2 = 0;
	foreach ( (array)$accountArray as $Account )
	{	
		// add to JS starting page array
		if (isset($startingpagearray))
			$startingpagearray .=',' . (string)$counter2;
		else
			$startingpagearray = (string)$counter2;
			
		$counter++;
		if (isset($arraystring))
			$arraystring .= ', "acc' .$counter . '"';
		else
			$arraystring = '"accanalysis", "acc' .$counter . '"';
			
		foreach ( (array)$Account['characters']['details'] as $Character )
		{
			$counter2++;
			
			if (isset($charactersarraystring))
				$charactersarraystring .= ', "char' .$counter2 . '"';
			else
				$charactersarraystring = '"char' .$counter2 . '"';
				
			if ($Character['director'] == 1)
			{
				$counter2++;
				$charactersarraystring .= ', "char' .$counter2 . '"';
				// add to known char/corps array - used to discount transactions in analysis
				$knownchars[] =  $Character['corporationID'];
			}
			
			// add to known char/corps array - used to discount transactions in analysis
			$knownchars[] =  $Character['characterID'];
		}
	}
	
	// prepare page
	$titlebar = $myPlayer;
	$title = "EVE API Trawler :: View Player - " . $myPlayer;
	require_once('includes/css.php');
	require_once('includes/javascript.php');
	require_once('includes/tablesortscript.php');
	require_once('includes/header.php');
	$footer = "</body></html>";
	
	// Do Account Tabs
	$accountcounter = 0;
	$page .= '	<div class="tabs">';
	foreach ( (array)$accountArray as $Account )
	{
		$accountcounter++;
		$page .= '	  <span id = "acc' . $accountcounter . '-tab" class="inactive-tab" onclick="activate(\'acc' . $accountcounter . '\')">
					  UserID: ' . $Account['userID'] . '
					  </span>';
	}
	$accountcounter++;
	
	$page .= '<span id="accanalysis-tab" class="active-tab"
				onclick="activate(\'accanalysis\')">
			<b>Analysis</b>
		  </span>';
	$page .= '</div>';
	
	// Do Account Pages
	$accountcounter = 0;
	$charactercounter = 0;
	foreach ( (array)$accountArray as $Account )
	{
		$accountcounter++;
		$page .= '	<div id="acc' . $accountcounter . '-page" class="inactive-page">';
		$page .= '<div class="tabs">';
		
		// Do Character Tabs
		$currentcharactercounter = $charactercounter;
		foreach ( (array)$Account['characters']['details'] as $Character )
		{
			$currentcharactercounter++;
			$page .= '	  <span id = "char' . $currentcharactercounter . '-tab2" class="inactive-tab2" onclick="activate(\'char' . $currentcharactercounter . '\')">
					  ' . $Character['name'] . '
					  </span>';
					  
			// If is a director add in Corp Tab
			if ($Character['director'] == 1)
			{
				$currentcharactercounter++;
				$page .= '	  <span id = "char' . $currentcharactercounter . '-tab2" class="inactive-tab2" onclick="activate(\'char' . $currentcharactercounter . '\')">
					  Corp: ' . $Character['corporationName'] . '
					  </span>';
			}
		}
		$page .= '</div>';
		
		// Do Character Pages
		$currentcharactercounter = $charactercounter;
		foreach ( (array)$Account['characters']['details'] as $Character )
		{
			// Character Details
			$currentcharactercounter++;
			$cachetime = ApiCache::get($Character['characterID'] . "_charsheet");
			$currenttime = ApiCurrent::get($Character['characterID'] . "_charsheet");
			$page .= '<div id="char' . $currentcharactercounter . '-page" class="inactive-page">
						<div class="header" onclick="toggle(\'ci-' . $currentcharactercounter . '\')">
						Character Information<div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
			
			$page .= '  <div id="ci-' . $currentcharactercounter . '" class="content" onclick="toggle(\'ci-' . $currentcharactercounter . '\')">
						  <b>corporation: </b>' . $Character['corporationName'] .'<br/>
						  <b>alliance: </b>' . $myAnalysis->getAllianceName($Character['corporationID']) .'<br/>
						  <b>balance: </b>' . number_format($Character['balance'], 2) .' isk<br/>
						  <b>currently training:</b> ' . $myAnalysis->getSkillInTraining($Character['characterID']) . '<br/>';
						  
			
			// Required Skills Table
			$skillsarray = $myAnalysis->getCharSkills($Character['characterID']);
			$missingskills = $myAnalysis->getMissingRequiredSkills($skillsarray);
			
			if ( count($missingskills) > 0 )
			{
				// draw table
				$page .= "<div class='required-skills'>The following required skills have not been trained:<br/>";
				foreach ($missingskills as $mskill)
				{
					$page .= "&bull;" . $mskill['typeName'] . ": " . $mskill['requiredLevel'] . "<br/>";
				}
				$page .= "</div>";
			}
			
			// Attributes Table
			if ($Character['slot1'] == "")
				$int = "<i>no implant</i>";
			else
				$int = $Character['slot1'];
			
			if ($Character['slot2'] == "")
				$mem = "<i>no implant</i>";
			else
				$mem = $Character['slot2'];
				
			if ($Character['slot3'] == "")
				$cha = "<i>no implant</i>";
			else
				$cha = $Character['slot3'];
				
			if ($Character['slot4'] == "")
				$per = "<i>no implant</i>";
			else
				$per = $Character['slot4'];
				
			if ($Character['slot5'] == "")
				$wil = "<i>no implant</i>";
			else
				$wil = $Character['slot5'];
				
			$page .= "<p>
					  <table border='1' cellpadding='2'>
					  <tr>
						<td align='center' colspan='2'>
						  <b>current attributes</b>
						</td>
						<td align='center'><b>implants</b></td>
					  </tr>
					  <tr>
						<td class='attr-name' align='right'>intelligence: </td>
						<td class='attr-value' align='right'>" . $Character['intelligence'] . "</td> 
						<td>" . $int . "</td>
					  </tr>
					  <tr>
						<td class='attr-name' align='right'>memory: </td>
						<td class='attr-value' align='right'>" . $Character['memory'] . "</td>
						<td>" . $mem . "</td> 
					  </tr>
					  <tr>
						<td class='attr-name' align='right'>charisma: </td>
						<td class='attr-value' align='right'>" . $Character['charisma'] . "</td> 
						<td>" . $cha . "</td>
					  </tr>
					  <tr>
						<td class='attr-name' align='right'>perception: </td>
						<td class='attr-value' align='right'>" . $Character['perception'] . "</td>
						<td>" . $per . "</td>
					  </tr>
					  <tr>
						<td class='attr-name' align='right'>willpower: </td>
						<td class='attr-value' align='right'>" . $Character['willpower'] . "</td>
						<td>" . $wil . "</td>
					  </tr>
					  </table></p>";
					
			// Character Skills		
			$totalSP = 0;
			$currentGroup = "";
			foreach ((array)$skillsarray as $skill)
			{
				// write group headers when group changes
				if ($skill['groupName'] != $currentGroup)
				{
					$currentGroup = $skill['groupName'];
					$page .= '<br/><b>' . $currentGroup . '</b><br/>';
				}
				$page .= $skill['typeName'] . ': ' . $skill['level'] . '<br/>';
				$totalSP += $skill['skillpoints'];
			}
			// write skillpoints
			$page .= '<br/>
					  <b>skillpoints:</b> ' . number_format($totalSP, 0) . '</div>';
			// END OF CHARACTER INFORMATION
			
			// ASSETS LIST
			$assetsarray = $myAnalysis->getAssets($Character['characterID']);
			$cachetime = ApiCache::get($Character['characterID'] . "_assetlist");
			$currenttime = ApiCurrent::get($Character['characterID'] . "_assetlist");
			if (count($assetsarray) > 0)
			{
				$page .= '<div class="header" onclick="toggle(\'al-' . $currentcharactercounter . '\')">
						Assets List<div class="right-element">(trawled: ' . $currenttime . ')</div></div>
					  <div id="al-' . $currentcharactercounter . '" class="content-minimized" onclick="toggle(\'al-' . $currentcharactercounter . '\')">';
			
				$currentLocation = "";
				$isContainer = 0;
				unset($containerlevel);
				$levelnumber = 0;
				foreach ((array)$assetsarray as $asset)
				{
					// write Location headers when location changes
					if ($asset['LocationName'] != $currentLocation)
					{
						// close of container indent if it's carrying on from a previous station
						if ($isContainer != 0)
						{
							$isContainer = 0;
							unset($containerlevel);
							for ($i=1;$i<=$levelnumber;$i++)
							{
								$page .= '</dd></dl>';
							}
							$levelnumber = 0;
						}
						while ($levelnumber > 0)
						{
							$page .= '</dd></dl>';
							unset($containerlevel[$levelnumber]);
							$levelnumber--;
						}
						$currentLocation = $asset['LocationName'];
						$locDetail = $myAnalysis->checkStation($asset['locationID']);
						if (!$locDetail)
						{
							$page .= '<br><b>' . $currentLocation . '</b><br/>';
							$isConquerable = false;
						} else {
							$page .= '<br><b>' . $currentLocation . ' ' . $locDetail . '</b><br/>';
							$conqstationdetail = $currentLocation . ' ' . $locDetail;
							$isConquerable = true;
						}
					}
				
					// indent items within container
					if ($asset['container'] != $isContainer)
					{
						// if $iscontainer = 0 then we are at root level
						if ($isContainer == 0)
						{
							// add this new container ID to our array to track where we are in the grand scheme of things
							$page .= '<dl class=\'assets\'><dd>';
							$containerlevel[] = $asset['container'];
							$levelnumber++;
						} else {
							if ($asset['container'] == 0)
							{
								$page .= '</dd></dl>';
								unset($containerlevel[$levelnumber]);
								$levelnumber--;
							} else {
								// determine if we just went up or down a level
								$levelmatch = false;
								foreach((array)$containerlevel as $level)
								{
									if ($level == $asset['container'])
										$levelmatch = true;
								}
							
								if ($levelmatch)
								{
									// matched a level, we've gone down a level
									$page .= '</dd></dl>';
									unset($containerlevel[$levelnumber]);
									$levelnumber--;
								} else {
									/// we went up a level
									$page .= '<dl class=\'assets\'><dd>';
									$containerlevel[] = $asset['container'];
									$levelnumber++;
								}
							}
						}
					} 
					unset($assetfname);
					if ($asset['flagname'] != "")
					{
						if ( ($asset['flag'] >= 116) && ($asset['flag'] <= 121) )
						{
							// is in a corp hangar div - we don't have division names here so give numerical hangar
							$divnum = $asset['flag']-114;
								$assetfname = "(hangar: " . $divnum . ")";
						} else {
							$assetfname = "(" . $asset['flagname'] . ")";
						}
					}
					$page .= number_format($asset['quantity'],0) . 'x ' . $asset['itemName'] . ' ' . $assetfname . '<br/>';
	
					// inc asset counter if station is conquerable
					if ($isConquerable)
						$ConquerableAssets[$Character['name']][$conqstationdetail]++;
						
					$isContainer = $asset['container'];
				}
				$page .= '</div>';
			} else {
				$page .= '<div class="header">
						<i>character has no assets</i><div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
			}
			// END OF ASSETS LIST
			
			// INDUSTRY JOBS
			$jobsarray = $myAnalysis->getIndustryJobs($Character['characterID']);
			$cachetime = ApiCache::get($Character['characterID'] . "_industryjobs");
			$currenttime = ApiCurrent::get($Character['characterID'] . "_industryjobs");
			if (count($jobsarray) > 0)
			{
				$page .= '<div class="header" onclick="toggle(\'ij-' . $currentcharactercounter . '\')">
						Industry Jobs<div class="right-element">(trawled: ' . $currenttime . ')</div></div>
					  <div id="ij-' . $currentcharactercounter . '" class="content-minimized" onclick="toggle(\'ij-' . $currentcharactercounter . '\')">';
			
				$listmode = "list-odd";
				foreach ((array)$jobsarray as $job)
				{	
					if ($job['completed'] == 1)
						$state = "(completed)";
					else
						$state = "(in progress)";
					
					// need to check if station is conquerable, if so add in the corp and alliance owners
					$locDetail = $myAnalysis->checkStation($job['installedItemLocationID']);
					if (!$locDetail)
						$locationName = $job['locationName'];
					else 
						$locationName =  $job['locationName'] . ' ' . $locDetail;
						
					// if location is unresolved, it must be at a pos (this shouldn't happen here in player, has to be corp)
					if ($locationName == "<unresolved ID>")
						$locationName = $job['solarSystemName'] . " POS";
				
					// alternate listmode
					if ($listmode == "list-odd")
						$listmode = "list-even";
					else
						$listmode = "list-odd";
				
					$page .= '<div class=\'' . $listmode . '\'>' . $job['installTime'] . ' - ' . $job['inputItem'] . '&rarr;' . $job['outputItem'] . ' at: ' . $locationName . ' ' . $state . '</div>';
			
				}  
				$page .= '</div>';
			} else {
				$page .= '<div class="header">
						<i>character has no industry jobs</i><div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
			}
			// END OF INDUSTRY JOBS
			
			// KILL LOG
			$killsarray = $myAnalysis->getKillLog($Character['characterID']);
			$cachetime = ApiCache::get($Character['characterID'] . "_killlog");
			$currenttime = ApiCurrent::get($Character['characterID'] . "_killlog");
			if (count($killsarray) > 0)
			{
				$page .= '<div class="header" onclick="toggle(\'kl-' . $currentcharactercounter . '\')">
						Kill Log (killing blows)<div class="right-element">(trawled: ' . $currenttime . ')</div></div>
					  <div id="kl-' . $currentcharactercounter . '" class="content-minimized" onclick="toggle(\'kl-' . $currentcharactercounter . '\')">';
		  
				$listmode = "list-odd";
				foreach ((array)$killsarray as $kill)
				{	
					// alternate listmode
					if ($listmode == "list-odd")
						$listmode = "list-even";
					else
						$listmode = "list-odd";
				
					if ($kill['characterName'] == "")
						$victim = "<i>player has been biomassed</i>";
					else
						$victim = $kill['characterName'];
					
					if ($kill['corporationName'] == "")
						$corp = "<i>corp has closed</i>";
					else
						$corp = $kill['corporationName'];
				
					if ($kill['allianceName'] == "")
						$alliance = "";
					else
						$alliance = "; " . $kill['allianceName'];
					
					$page .= '<div class=\'' . $listmode . '\'>' . $kill['killTime'] . ' -  <b>' . $victim . '</b> (' . $corp . $alliance . ') -  <b>' . $kill['itemName'] . '</b> in ' . $kill['solarSystemName'] . ', involved: ' . $kill['aggressors'] . '</div>';
				}
				$page .= '</div>';
			} else {
				$page .= '<div class="header">
						<i>character has no kill logs</i><div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
			}
			// END OF KILL LOG
			
			// MARKET ORDERS
			$ordersarray = $myAnalysis->getMarketOrders($Character['characterID']);	
			$cachetime = ApiCache::get($Character['characterID'] . "_marketorders");
			$currenttime = ApiCurrent::get($Character['characterID'] . "_marketorders");
			if (count($ordersarray) > 0)
			{
				$page .= '<div class="header" onclick="toggle(\'mo-' . $currentcharactercounter . '\')">
			Market Orders<div class="right-element">(trawled: ' . $currenttime . ')</div></div>
		  <div id="mo-' . $currentcharactercounter . '" class="content-minimized" onclick="toggle(\'mo-' . $currentcharactercounter . '\')">';
		  
				$listmode = "list-odd";
				foreach ((array)$ordersarray as $order)
				{	
					// alternate listmode
					if ($listmode == "list-odd")
						$listmode = "list-even";
					else
						$listmode = "list-odd";
						
					if ($order['bid'] == 1)
						$ordertype = "buy";
					else
						$ordertype = "sell";
					
					$locDetail = $myAnalysis->checkStation($order['stationID']);
					if (!$locDetail)
						$locationName = $order['stationName'];
					else 
						$locationName =  $order['stationName'] . ' ' . $locDetail;
						
					$page .= '<div class=\'' . $listmode . '\'>' . $order['issued'] . ' [' . $ordertype . ' | ' . $order['volEntered'] . ' | ' . number_format($order['price'],2) . '] ' . $order['itemName'] . ' (' . $locationName . ')</div>';
						
				}
				$page .= '</div>';
			} else {
				$page .= '<div class="header">
						<i>character has no market orders</i><div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
			}
			// END OF MARKET ORDERS
			
			// WALLET JOURNAL
			$journalarray = $myAnalysis->getWalletJournal($Character['characterID'], 1000, $wjsort);	
			if (count($journalarray) > 0)
			{
				$cachetime = ApiCache::get($Character['characterID'] . "_walletjournal");
				$currenttime = ApiCurrent::get($Character['characterID'] . "_walletjournal");
				$page .= '<div class="header" onclick="toggle(\'wj-' . $currentcharactercounter . '\')">
							Wallet Journal<div class="right-element">(trawled: ' . $currenttime . ')</div></div>
						  <div id="wj-' . $currentcharactercounter . '" class="content-minimized">';
				
				// menu 
				$page .= '<table class="sortable" id="sortabletable" width=100% cellpadding=0 cellspacing=1 border=0><thead><tr><th width=160>Date</th><th>Type</th><th>Isk</th><th>Source</th><th>Recipient</th><th>Reason:</th></tr></thead><tbody>';
				
				$listmode = "sortable-row-odd";
				foreach ((array)$journalarray as $entry)
				{	
					// alternate listmode (disabled: JS does not sort)
					/*
					if ($listmode == "sortable-row-odd")
						$listmode = "sortable-row-even";
					else
						$listmode = "sortable-row-odd"; //*/
						
					if ($entry['ownerName1'] == "")
						$owner1 = "<i>n/a</i>";
					else
						$owner1 = $entry['ownerName1'];
						
					if ($entry['ownerName2'] == "")
						$owner2 = "<i>n/a</i>";
					else
						$owner2 = $entry['ownerName2'];	
					
					$page .= '<tr class=\'' . $listmode . '\'><td class=sortable-cell>' . $entry['date'] . '</td><td class=sortable-cell>' . $entry['refTypeName'] . '</td><td class=sortable-cell align="right">' . number_format( $entry['amount'], 2) . '</td><td class=sortable-cell>' . $owner1 . '</td><td class=sortable-cell>' . $owner2 . '</td><td class=sortable-cell>' . $entry['reason'] . '</td></tr>';
					/*if ($entry['reason'] != "")
					{
						$page .= '<br/>reason: <i>' . $entry['reason'] . '</i>';
					}
					$page .= '';*/
					
					// check if owner1 and owner2 both match $knownchars
					$ownerchar1 = false;
					$ownerchar2 = false;
					foreach ((array)$knownchars as $charcheck)
					{
						if ($charcheck == $entry['ownerID1'])
							$ownerchar1 = true;
							
						if ($charcheck == $entry['ownerID2'])
							$ownerchar2 = true;
					}
					if ( ($ownerchar1) && ($ownerchar2) )
					{
						// ignore this transaction as both IDs belong to this player we're viewing
					} else {
						// if 'player trade' (refTypeID = 1) add to array
						if ($entry['refTypeID'] == 1)
						{
							$playertrades[$owner1][$owner2]++;
						// elseif 'player Donation' (refTypeID = 10) add to array
						} elseif ($entry['refTypeID'] == 10) {
							$playerdonation[$owner1][$owner2] += $entry['amount'];
						} else { //if ( ($entry['refTypeID'] == 2) || ($entry['refTypeID'] == 68) ) {
							$othertransfers[$owner1][$owner2] += $entry['amount'];
						}
					}
				}	
				$page .= '</tbody><tfoot></tfoot></table></div>';
			} else {
				$page .= '<div class="header">
						<i>character has no wallet journal entries</i><div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
			}  
			// END OF WALLET JOURNAL
			
			// WALLET TRANSACTIONS
			$transactionarray = $myAnalysis->getWalletTransactions($Character['characterID']);	
			$cachetime = ApiCache::get($Character['characterID'] . "_wallettransactions");
				$currenttime = ApiCurrent::get($Character['characterID'] . "_wallettransactions");
			if (count($transactionarray) > 0)
			{
				$page .= '<div class="header" onclick="toggle(\'wt-' . $currentcharactercounter . '\')">
							Wallet Transactions<div class="right-element">(trawled: ' . $currenttime . ')</div></div>
						  <div id="wt-' . $currentcharactercounter . '" class="content-minimized" onclick="toggle(\'wt-' . $currentcharactercounter . '\')">';
				
				$listmode = "list-odd";
				foreach ((array)$transactionarray as $transaction)
				{	
					// alternate listmode
					if ($listmode == "list-odd")
						$listmode = "list-even";
					else
						$listmode = "list-odd";
						
					if ($transaction['clientName'] == "")
						$client = "<i>n/a</i>";
					else
						$client = $transaction['clientName'];
					
					$locDetail = $myAnalysis->checkStation($transaction['stationID']);
					if (!$locDetail) {
						$locationName = $transaction['stationName'];
					} else { 
						$locationName =  $transaction['stationName'] . ' ' . $locDetail;
					}
								
					$page .= '<div class=\'' . $listmode . '\'>' . $transaction['transactionDateTime'] . ' [ ' . $transaction['transactionType'] . ' | ' . $transaction['transactionFor'] . ' | ' . $transaction['quantity'] . ' | ' . number_format($transaction['price'],2) . ' ] <b>' . $client . '</b> (' . $transaction['typeName'] . '; ' . $locationName . ')</div>';
				}
				$page .= '</div>';
			} else {
				$page .= '<div class="header">
						<i>character has no wallet transactions</i><div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
			}  
			// END OF WALLET TRANSACTIONS		
			
			// STANDINGS
			$charstandingscorp = $myAnalysis->getStandings($Character['characterID'], "char", "corp");
			$charstandingschar = $myAnalysis->getStandings($Character['characterID'], "char", "char");
				
			$cachetime = ApiCache::get($Character['characterID'] . "_standings");
			$currenttime = ApiCurrent::get($Character['characterID'] . "_standings");	
			if ( (count($charstandingscorp) > 0) || (count($charstandingschar) > 0) )
			{
				$page .= '<div class="header" onclick="toggle(\'st-' . $currentcharactercounter . '\')">
						  Standings<div class="right-element">(trawled: ' . $currenttime . ')</div></div>
						  <div id="st-' . $currentcharactercounter . '" class="content-minimized" onclick="toggle(\'st-' .
						  $currentcharactercounter . '\')">';
		  
				$listmode = "list-odd";
					
				// Character
				if ( (count($charstandingscorp) > 0) || (count($charstandingschar) > 0) )
				{
					// character to corporations
					$page .= '<b>Character Standings:' . '</b><br>';
					if ( count($charstandingscorp) > 0 )
					{
						$page .= '<i>corporations:' . '</i><br><dl class=\'assets\'><dd>';
						foreach ($charstandingscorp as $temp)
						{	
							// alternate listmode
							if ($listmode == "list-odd")
								$listmode = "list-even";
							else
								$listmode = "list-odd";
								
							$page .= '<div class=\'' . $listmode . '\'>' . $temp['toName'] . " - " . $temp['standing'] . '</div>';
						}
						$page .= '</dd></dl>';
					}
					
					// corporation to corporations
					if ( count($charstandingschar) > 0 )
					{
						$page .= '<i>characters:' . '</i><br><dl class=\'assets\'><dd>';
						foreach ($charstandingschar as $temp)
						{	
							// alternate listmode
							if ($listmode == "list-odd")
								$listmode = "list-even";
							else
								$listmode = "list-odd";
								
							$page .= '<div class=\'' . $listmode . '\'>' . $temp['toName'] . " - " . $temp['standing'] . '</div>';
						}
						$page .= '</dd></dl>';
					}
					
				}
				$page .= '</div>';
			} else {
				$page .= '<div class="header">
						<i>character has no standings set</i><div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
			}
			// END OF STANDINGS	
					  
			// end of page 
			$page .= '</div>';
			
			//
			// If is a director add in Corp Tab
			//
			// check if corp has been trawled before
			$trawlcheck = false;
			foreach ((array)$trawledcorps as $trawlc)
			{
				if ($trawlc == (integer)$Character['corporationID'])
					$trawlcheck = true;
			}
			if ($Character['director'] == 1) 
			{
				$currentcharactercounter++;
				$trawledcorps[] = (integer)$Character['corporationID'];
				$walletnames = $myAnalysis->getWalletNames($Character['corporationID']);
				$divnames = $myAnalysis->getDivisionNames($Character['corporationID']);
				$corpbalances = $myAnalysis->getAccountBalances($Character['corporationID']);
				
				$corpdetail = $myAnalysis->getCorpDetails($Character['corporationID']);
				if ($corpdetail['allianceName'] == "")
					$alliname = "None.";
				else
					$alliname = $corpdetail['allianceName'];
				
				$cachetime = ApiCache::get($Character['corporationID'] . "_corporationsheet");
				$currenttime = ApiCurrent::get($Character['corporationID'] . "_corporationsheet");
				$page .= '<div id="char' . $currentcharactercounter . '-page" class="inactive-page">
							<div class="header" onclick="toggle(\'ci-' . $currentcharactercounter . '\')">
							  Corporation Information<div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
			
				$page .= '  <div id="ci-' . $currentcharactercounter . '" class="content" onclick="toggle(\'ci-' . $currentcharactercounter . '\')">
							  <b>corporation: </b>' . $corpdetail['corporationName'] . ' [' . $corpdetail['ticker'] . ']<br/>
							  <b>alliance: </b>' . $alliname . '<br/>
							  <b>corporation balances: </b>';
				// do corp balances
				$page .= '<dd><dl>';
				for ($key=1000;$key<=1006;$key++)
				{
					$page .= '<b>' . $walletnames[$key] . ': </b>' . number_format($corpbalances[$key],2) . ' isk<br/>';
				}
				$page .= '</dd></dl>';		  
				$page .= '	  <b>ceo: </b>' . $corpdetail['ceoName'] . '<br/>
							  <b>headquarters: </b>' . $corpdetail['stationName'] . '<br/>
							  <b>website: </b>' . $corpdetail['url'] . '<br/>
							  <b>members: </b>' . $corpdetail['memberCount'] . '<br/>
							  <b>max members: </b>' . $corpdetail['memberLimit'] . '<br/>
							  <b>shares: </b>' . $corpdetail['shares'] . '<br/>
							  <b>tax rate: </b>' . $corpdetail['taxRate'] . '%<br/>
							  <b>description: </b><br/>' . $corpdetail['description'] . '<br/>
							</div>';
				
				
				// CORP ASSETS LIST
				$cachetime = ApiCache::get($Character['corporationID'] . "_corpassetlist");
				$currenttime = ApiCurrent::get($Character['corporationID'] . "_corpassetlist");
				$assetsarray = $myAnalysis->getAssets($Character['corporationID']);
				if (count($assetsarray) > 0)
				{
					$page .= '<div class="header" onclick="toggle(\'al-' . $currentcharactercounter . '\')">
						Assets List<div class="right-element">(trawled: ' . $currenttime . ')</div></div>
					  <div id="al-' . $currentcharactercounter . '" class="content-minimized" onclick="toggle(\'al-' . $currentcharactercounter . '\')">';
			
					$currentLocation = "";
					$isContainer = 0;
					unset($containerlevel);
					$levelnumber = 0;
					foreach ((array)$assetsarray as $asset)
					{
						// write Location headers when location changes
						if ( ($asset['LocationName'] != $currentLocation) )
						{
							// close of container indent if it's carrying on from a previous station
							if ($isContainer != 0)
							{
								$isContainer = 0;
								unset($containerlevel);
								for ($i=1;$i<=$levelnumber;$i++)
								{
									$page .= '</dd></dl>';
								}
								$levelnumber = 0;
							}
							while ($levelnumber > 0)
							{
								$page .= '</dd></dl>';
								unset($containerlevel[$levelnumber]);
								$levelnumber--;
							}
							$currentLocation = $asset['LocationName'];
							$locDetail = $myAnalysis->checkStation($asset['locationID']);
							if (!$locDetail)
							{
								$page .= '<br><b>' . $currentLocation . '</b><br/>';
								$isConquerable = false;
							} else {
								$page .= '<br><b>' . $currentLocation . ' ' . $locDetail . '</b><br/>';
								$conqstationdetail = $currentLocation . ' ' . $locDetail;
								$isConquerable = true;
							}
							
							if ( $asset['itemName'] == "Office" )
								$isOffice = true;
							else
								$isOffice = false;
						}
				
						// indent items within container
						if ($asset['container'] != $isContainer)
						{
							// if $iscontainer = 0 then we are at root level
							if ($isContainer == 0)
							{
								// add this new container ID to our array to track where we are in the grand scheme of things
								$page .= '<dl class=\'assets\'><dd>';
								$containerlevel[] = $asset['container'];
								$levelnumber++;
							} else {
								if ($asset['container'] == 0)
								{
									$page .= '</dd></dl>';
									unset($containerlevel[$levelnumber]);
									$levelnumber--;
								} else {
									// determine if we just went up or down a level
									$levelmatch = false;
									foreach((array)$containerlevel as $level)
									{
										if ($level == $asset['container'])
											$levelmatch = true;
									}
								
									if ($levelmatch)
									{
										// matched a level, we've gone down a level
										$page .= '</dd></dl>';
										unset($containerlevel[$levelnumber]);
										$levelnumber--;
									} else {
										/// we went up a level
										$page .= '<dl class=\'assets\'><dd>';
										$containerlevel[] = $asset['container'];
										$levelnumber++;
									}
								}
							}
						}
						
						unset($assetfname);
						if ($asset['flagname'] != "")
						{
							if ( ($asset['flag'] >= 116) && ($asset['flag'] <= 121) )
							{
								// is in a corp hangar div
								$divnum = $asset['flag']-115;
								$assetfname = "(" . $divnames[$divnum] . ")";
							} else {
								$assetfname = "(" . $asset['flagname'] . ")";
							}
						} elseif ($asset['flag'] == 4) {
							if  ((!$isOffice) && ($levelnumber == 0) )
								$assetfname = "(impounded)"; // could be deliveries or something else as well
							else
								$assetfname = "(" . $divnames[0] . ")";
						}
						$page .= number_format($asset['quantity'],0) . 'x ' . $asset['itemName'] . ' ' . $assetfname . '<br/>';
						
						// if this corp has not been trawled before, inc asset counter if station is conquerable
						if (!$trawlcheck)
						{
							if ($isConquerable)
								$CorpConquerableAssets[$corpdetail['corporationName']][$conqstationdetail]++;
						}
						
						$isContainer = $asset['container'];
					}
			
					//$page .= '</div>';
					$page .= '</div>';
				} else {
					$page .= '<div class="header">
						<i>corporation has no assets</i><div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
				}
				// END OF CORP ASSETS LIST
				
				// CORP INDUSTRY JOBS
				$cachetime = ApiCache::get($Character['corporationID'] . "_corpindustryjobs");
				$currenttime = ApiCurrent::get($Character['corporationID'] . "_corpindustryjobs");
				$jobsarray = $myAnalysis->getIndustryJobs($Character['corporationID']);	  
				if (count($jobsarray) > 0)
				{
					$page .= '<div class="header" onclick="toggle(\'ij-' . $currentcharactercounter . '\')">
								Industry Jobs<div class="right-element">(trawled: ' . $currenttime . ')</div></div>
							 <div id="ij-' . $currentcharactercounter . '" class="content-minimized" onclick="toggle(\'ij-' . $currentcharactercounter . '\')">';
				
					$listmode = "list-odd";
					foreach ((array)$jobsarray as $job)
					{	
						if ($job['completed'] == 1)
							$state = "(completed)";
						else
							$state = "(in progress)";
						
						// need to check if station is conquerable, if so add in the corp and alliance owners
						$locDetail = $myAnalysis->checkStation($job['installedItemLocationID']);
						if (!$locDetail)
							$locationName = $job['locationName'];
						else 
							$locationName = $job['locationName'] . ' ' . $locDetail;
						
						// if location is unresolved, it must be at a pos
						if ($locationName == "<unresolved ID>")
							$locationName = $job['solarSystemName'] . " POS";
						
						// alternate listmode
						if ($listmode == "list-odd")
							$listmode = "list-even";
						else
							$listmode = "list-odd";
					
						$page .= '<div class=\'' . $listmode . '\'>' . $job['installTime'] . ' - ' . $job['inputItem'] . '&rarr;' . $job['outputItem'] . ' at: ' . $locationName . ' ' . $state . '</div>';
				
					}  
					$page .= '</div>';
				} else {
					$page .= '<div class="header">
						<i>corporation has no industry jobs</i><div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
				}
				// END OF CORP INDUSTRY JOBS
			
				// CORP KILL LOG
				$killsarray = $myAnalysis->getKillLog($Character['corporationID']);
				$cachetime = ApiCache::get($Character['corporationID'] . "_corpkilllog");
				$currenttime = ApiCurrent::get($Character['corporationID'] . "_corpkilllog");
				if (count($killsarray) > 0)
				{
					$page .= '<div class="header" onclick="toggle(\'kl-' . $currentcharactercounter . '\')">
							Kill Log (killing blows)<div class="right-element">(trawled: ' . $currenttime . ')</div></div>
						  <div id="kl-' . $currentcharactercounter . '" class="content-minimized" onclick="toggle(\'kl-' . $currentcharactercounter . '\')">';
			  
					$listmode = "list-odd";
					foreach ((array)$killsarray as $kill)
					{	
						// alternate listmode
						if ($listmode == "list-odd")
							$listmode = "list-even";
						else
							$listmode = "list-odd";
					
						if ($kill['characterName'] == "")
							$victim = "<i>player has been biomassed</i>";
						else
							$victim = $kill['characterName'];
						
						if ($kill['corporationName'] == "")
							$corp = "<i>corp has closed</i>";
						else
							$corp = $kill['corporationName'];
					
						if ($kill['allianceName'] == "")
							$alliance = "";
						else
							$alliance = "; " . $kill['allianceName'];
						
						$page .= '<div class=\'' . $listmode . '\'>' . $kill['killTime'] . ' -  <b>' . $victim . '</b> (' . $corp . $alliance . ') -  <b>' . $kill['itemName'] . '</b> in ' . $kill['solarSystemName'] . ', involved: ' . $kill['aggressors'] . '</div>';
					}
					$page .= '</div>';
				} else {
					$page .= '<div class="header">
						<i>corporation has no kill logs</i><div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
				}
				// END OF CORP KILL LOG
				
				// CORP MARKET ORDERS
				$ordersarray = $myAnalysis->getMarketOrders($Character['corporationID']);	
				$cachetime = ApiCache::get($Character['corporationID'] . "_corpmarketorders");
				$currenttime = ApiCurrent::get($Character['corporationID'] . "_corpmarketorders");
				if (count($ordersarray) > 0)
				{
					$page .= '<div class="header" onclick="toggle(\'mo-' . $currentcharactercounter . '\')">
			Market Orders<div class="right-element">(trawled: ' . $currenttime . ')</div></div>
		  <div id="mo-' . $currentcharactercounter . '" class="content-minimized" onclick="toggle(\'mo-' . $currentcharactercounter . '\')">';
		  
					$listmode = "list-odd";
					foreach ((array)$ordersarray as $order)
					{	
						// alternate listmode
						if ($listmode == "list-odd")
							$listmode = "list-even";
						else
							$listmode = "list-odd";
						
						if ($order['bid'] == 1)
							$ordertype = "buy";
						else
							$ordertype = "sell";
					
						$locDetail = $myAnalysis->checkStation($order['stationID']);
						if (!$locDetail)
							$locationName = $order['stationName'];
						else 
							$locationName =  $order['stationName'] . ' ' . $locDetail;
						
						$page .= '<div class=\'' .$listmode .'\'>' . $order['issued'] . ' <b>' . $order['charName'] . '</b> [' . $ordertype . ' | ' . $order['volEntered'] . ' | ' . number_format($order['price'],2) . '] ' . $order['itemName'] . ' (' . $locationName . ')</div>';
						
					}
					$page .= '</div>';
				} else {
					$page .= '<div class="header">
					<i>corporation has no market orders</i><div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
				}
				// END OF CORP MARKET ORDERS
			
				// CORP WALLET JOURNAL
				$journalexists = false;	
				unset($journalarray);
				
				for ($key=1000;$key<=1006;$key++)
				{
					$journal = $myAnalysis->getWalletJournal($Character['corporationID'], $key, $wjsort);
					if (count($journal) > 0)
						$journalexists = true;
					$journalarray[] = $journal;
				}
				$cachetime = ApiCache::get($Character['corporationID'] . "_1000_corpwalletjournal");
				$currenttime = ApiCurrent::get($Character['corporationID'] . "_1000_corpwalletjournal");	
				if ($journalexists)
				{
					$page .= '<div class="header" onclick="toggle(\'wj-' . $currentcharactercounter . '\')">
							Wallet Journal<div class="right-element">(trawled: ' . $currenttime . ')</div></div>
						  <div id="wj-' . $currentcharactercounter . '" class="content-minimized">';
		
					$journalnumber = 999;
					foreach ((array)$journalarray as $journal)
					{
						$journalnumber++;
						$listmode = "sortable-row-odd";
						
						if (count($journal) > 0)
						{
							$page .= '<b>wallet: ' . $walletnames[$journalnumber] . '</b><br/>';
							// table
							$page .= '<table class="sortable" id="sortabletable" width=100% cellpadding=0 cellspacing=1 border=0><thead><tr><th width=160>Date</th><th>Type</th><th>Isk</th><th>Source</th><th>Recipient</th><th>Reason:</th></tr></thead><tbody>';
							foreach ((array)$journal as $entry)
							{	
								// alternate listmode (abandoned as JS script doesn't sort it) 
								/*
								if ($listmode == "sortable-row-odd")
									$listmode = "sortable-row-even";
								else
									$listmode = "sortable-row-odd"; //*/
						
								if ($entry['ownerName1'] == "")
									$owner1 = "<i>n/a</i>";
								else
									$owner1 = $entry['ownerName1'];
						
								if ($entry['ownerName2'] == "")
									$owner2 = "<i>n/a</i>";
								else
									$owner2 = $entry['ownerName2'];	
					
								$page .= '<tr class=\'' . $listmode . '\'><td class=sortable-cell>' . $entry['date'] . '</td><td class=sortable-cell>' . $entry['refTypeName'] . '</td><td class=sortable-cell align="right">' . number_format( $entry['amount'], 2) . '</td><td class=sortable-cell>' . $owner1 . '</td><td class=sortable-cell>' . $owner2 . '</td><td class=sortable-cell>' . $entry['reason'] . '</td></tr>';
								
								// if this corp has not been trawled before
								if (!$trawlcheck)
								{
									// check if owner1 and owner2 both match $knownchars
									$ownerchar1 = false;
									$ownerchar2 = false;
									foreach ((array)$knownchars as $charcheck)
									{
										if ($charcheck == $entry['ownerID1'])
											$ownerchar1 = true;
							
										if ($charcheck == $entry['ownerID2'])
											$ownerchar2 = true;
									}
									if ( ($ownerchar1) && ($ownerchar2) )
									{
										// ignore this transaction as both IDs belong to this player we're viewing
									} else {
										// if 'player trade' (refTypeID = 1) add to array - shouldn't occurr in corp section
										if ($entry['refTypeID'] == 1)
										{
											$corptrades[$owner1][$owner2]++;
										// elseif 'player Donation' (refTypeID = 10) add to array or Corp Account withdrawal (37)
										} elseif ( ($entry['refTypeID'] == 10) || ($entry['refTypeID'] == 37) ) {
											$corpdonation[$owner1][$owner2] += $entry['amount'];
										} else { //if ( ($entry['refTypeID'] == 2) || ($entry['refTypeID'] == 68) ) {
											$corpothertransfers[$owner1][$owner2] += $entry['amount'];
										}
									}
								}
							}
							$page .= '</tbody><tfoot></tfoot></table>';
						} else {
							$page .= '<br><b><i>wallet: ' . $walletnames[$journalnumber] . ' has no entries</i></b><br/>';
						}
					}
					$page .= '</div>';
				} else {
					$page .= '<div class="header">
						<i>corporation has no wallet journal entries</i><div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
				}  
				// END CORP OF WALLET JOURNAL
				
				// CORP WALLET TRANSACTIONS
				$transactionsexists = false;	
				unset($transactionarray);
				
				for ($key=1000;$key<=1006;$key++)
				{
					$trans = $myAnalysis->getWalletTransactions($Character['corporationID'], $key);
					if (count($trans) > 0)
						$transactionsexists = true;
					$transactionarray[] = $trans;
				}	
				$cachetime = ApiCache::get($Character['corporationID'] . "_1000_corpwallettransactions");
				$currenttime = ApiCurrent::get($Character['corporationID'] . "_1000_corpwallettransactions");
				if ($transactionsexists)
				{	
					$page .= '<div class="header" onclick="toggle(\'wt-' . $currentcharactercounter . '\')">
							Wallet Transactions<div class="right-element">(trawled: ' . $currenttime . ')</div></div>
						  <div id="wt-' . $currentcharactercounter . '" class="content-minimized" onclick="toggle(\'wt-' . $currentcharactercounter . '\')">';
				
					$journalnumber = 999;
					foreach ((array)$transactionarray as $transactions)
					{
						$journalnumber++;
						$listmode = "list-odd";
						
						if (count($transactions) > 0)
						{
							$page .= '<b>wallet: ' . $walletnames[$journalnumber] . '</b><br/>';
							foreach ((array)$transactions as $transaction)
							{	
								// alternate listmode
								if ($listmode == "list-odd")
									$listmode = "list-even";
								else
									$listmode = "list-odd";
						
								if ($transaction['clientName'] == "")
									$client = "<i>n/a</i>";
								else
									$client = $transaction['clientName'];
								
								$locDetail = $myAnalysis->checkStation($transaction['stationID']);
								if (!$locDetail) {
									$locationName = $transaction['stationName'];
								} else { 
									$locationName =  $transaction['stationName'] . ' ' . $locDetail;
								}
						
								$page .= '<div class=\'' . $listmode . '\'>' . $transaction['transactionDateTime'] . ' [ ' . $transaction['transactionType'] . ' | ' . $transaction['transactionFor'] . ' | ' . $transaction['quantity'] . ' | ' . number_format($transaction['price'],2) . ' ] <b>' . $client . '</b> (' . $transaction['typeName'] . '; ' . $locationName . ')</div>';
							} 
						} else {
							$page .= '<br><b><i>wallet: ' . $walletnames[$journalnumber] . ' has no entries</i></b><br/>';
						}
					}
					$page .= '</div>';
				} else {
					$page .= '<div class="header">
						<i>corporation has no wallet transactions</i><div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
				}
				// END OF CORP WALLET TRANSACTIONS
				
				// CORP STARBASELIST
				$stationsarray = $myAnalysis->getStations($Character['corporationID']);	
				$posarray = $myAnalysis->getPos($Character['corporationID']);
				$cachetime = ApiCache::get($Character['corporationID'] . "_starbaselist");
				$currenttime = ApiCurrent::get($Character['corporationID'] . "_starbaselist");	
				if ( (count($stationsarray) > 0) || (count($posarray) > 0) )
				{
					$page .= '<div class="header" onclick="toggle(\'sb-' . $currentcharactercounter . '\')">
							  Star Bases<div class="right-element">(trawled: ' . $currenttime . ')</div></div>
							  <div id="sb-' . $currentcharactercounter . '" class="content-minimized" onclick="toggle(\'sb-' . $currentcharactercounter . '\')">';
		  
					$listmode = "list-odd";
					
					// Stations
					if ( count($stationsarray) > 0 )
						$page .= '<b>stations:' . '</b><br/>';
					foreach ((array)$stationsarray as $basestation)
					{	
						// alternate listmode
						if ($listmode == "list-odd")
							$listmode = "list-even";
						else
							$listmode = "list-odd";
					
						$page .= '<div class=\'' . $listmode . '\'>' . $basestation . '</div>';
					}
					
					// Pos's
					if ( count($posarray) > 0 )
						$page .= '<b>pos\'s:' . '</b><br/>';
					foreach ((array)$posarray as $basepos)
					{	
						// alternate listmode
						if ($listmode == "list-odd")
							$listmode = "list-even";
						else
							$listmode = "list-odd";
					
						$page .= '<div class=\'' . $listmode . '\'>' . $basepos . '</div>';
					}
					
					$page .= '</div>';
				} else {
					$page .= '<div class="header">
						<i>corporation has no star bases</i><div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
				}
				// END OF CORP STARBASELIST
				
				// CORP MEMBERLIST
				$membersarray = $myAnalysis->getMembers($Character['corporationID']);
				$cachetime = ApiCache::get($Character['corporationID'] . "_membertracking");
				$currenttime = ApiCurrent::get($Character['corporationID'] . "_membertracking");		
				if ( (count($membersarray) > 0) )
				{
					$page .= '<div class="header" onclick="toggle(\'mt-' . $currentcharactercounter . '\')">
			Member Tracking<div class="right-element">(trawled: ' . $currenttime . ')</div></div>
		  <div id="mt-' . $currentcharactercounter.'" class="content-minimized" onclick="toggle(\'mt-' . $currentcharactercounter . '\')">';
		  
					$listmode = "list-odd";
					
					// Members
					foreach ((array)$membersarray as $member)
					{	
						// alternate listmode
						if ($listmode == "list-odd")
							$listmode = "list-even";
						else
							$listmode = "list-odd";
						
						if ( $member['title'] != "" )
							$mtitle = " \"" . $member['title'] . "\"";
						else
							$mtitle = "";
						
						$locDetail = $myAnalysis->checkStation($member['locationID']);
						if (!$locDetail)
						{
							$locationName = $member['location'];
							
							// test to see if they're in a wormhole (id = location for some reason)
							if ( $member['locationID'] == $member['location'] )
								$locationName = $myAnalysis->getSystemName($member['locationID']);
						} else { 
							$locationName =  $member['location'] . ' ' . $locDetail;
						}
						$memberstring = $member['name'] . $mtitle . " - <b>joined:</b> " . $member['startDateTime'] . " <b>logged in:</b> " . $member['logonDateTime'] . " <b>logged off:</b> " . $member['logoffDateTime'] . "<br><b>location:</b> " . $locationName . " (" . $member['shipType'] . ")";
						
						$page .= '<div class=\'' . $listmode . '\'>' . $memberstring . '</div>';
					}
					$page .= '</div>';
				} else {
					$page .= '<div class="header">
						<i>corporation has no members, which doesn\'t make much sense. Hopefully you will never read this or even know that I took the time to put this message in on the offchance you trawl a guy who is a director in a corporation that has no members</i><div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
				}
				// END OF CORP MEMBERLIST
				
				// CORP SHAREHOLDERS
				$corpholdersarray = $myAnalysis->getShareholders($Character['corporationID'], 1);
				$charholdersarray = $myAnalysis->getShareholders($Character['corporationID'], 0);
				
				$cachetime = ApiCache::get($Character['corporationID'] . "_shareholders");
				$currenttime = ApiCurrent::get($Character['corporationID'] . "_shareholders");	
				if ( (count($corpholdersarray) > 0) || (count($charholdersarray) > 0) )
				{
					$page .= '<div class="header" onclick="toggle(\'sh-' . $currentcharactercounter . '\')">
							  Shareholders<div class="right-element">(trawled: ' . $currenttime . ')</div></div>
							  <div id="sh-' . $currentcharactercounter . '" class="content-minimized" onclick="toggle(\'sh-' . $currentcharactercounter . '\')">';
		  
					$listmode = "list-odd";
					
					// Corporation holders
					if ( count($corpholdersarray) > 0 )
						$page .= '<b>corporations:' . '</b><br/>';
					foreach ((array)$corpholdersarray as $holder)
					{	
						// alternate listmode
						if ($listmode == "list-odd")
							$listmode = "list-even";
						else
							$listmode = "list-odd";
						
						$page .= '<div class=\'' . $listmode . '\'>' . $holder['shareholderName'] . " - " . $holder['shares'] . '</div>';
					}
					
					// Character holders
					if ( count($charholdersarray) > 0 )
						$page .= '<b>characters:' . '</b><br/>';
					foreach ((array)$charholdersarray as $holder)
					{	
						// alternate listmode
						if ($listmode == "list-odd")
							$listmode = "list-even";
						else
							$listmode = "list-odd";
					
						$page .= '<div class=\'' . $listmode . '\'>' . $holder['shareholderName'] . " (" . 
								$holder['shareholderCorporationName'] . ") - " . $holder['shares'] . '</div>';
					}
					
					$page .= '</div>';
				} else {
					$page .= '<div class="header">
						<i>corporation has no shareholders</i><div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
				}
				// END OF CORP SHAREHOLDERS
				
				// CORP STANDINGS
				$alliancestandingsalliance = $myAnalysis->getStandings($Character['corporationID'], "alliance", "alliance");
				$alliancestandingscorp = $myAnalysis->getStandings($Character['corporationID'], "alliance", "corp");
				$corporationstandingsalliance = $myAnalysis->getStandings($Character['corporationID'], "corp", "alliance");
				$corporationstandingscorp = $myAnalysis->getStandings($Character['corporationID'], "corp", "corp");
				$corporationstandingschar = $myAnalysis->getStandings($Character['corporationID'], "corp", "char");
				
				$cachetime = ApiCache::get($Character['corporationID'] . "_corpstandings");
				$currenttime = ApiCurrent::get($Character['corporationID'] . "_corpstandings");	
				if ( (count($alliancestandingsalliance) > 0) || (count($alliancestandingscorp) > 0) ||
					 (count($corporationstandingsalliance) > 0) || (count($corporationstandingscorp) > 0) ||
					 (count($corporationstandingschar) > 0) )
				{
					$page .= '<div class="header" onclick="toggle(\'st-' . $currentcharactercounter . '\')">
							  Standings<div class="right-element">(trawled: ' . $currenttime . ')</div></div>
							  <div id="st-' . $currentcharactercounter . '" class="content-minimized" onclick="toggle(\'st-' . $currentcharactercounter . '\')">';
		  
					$listmode = "list-odd";
					
					// alliances
					if ( (count($alliancestandingsalliance) > 0) || (count($alliancestandingscorp) > 0) )
					{
						// alliances to alliance
						$page .= '<b>Alliance Standings:' . '</b><br>';
						if ( count($alliancestandingsalliance) > 0 )
						{
							$page .= '<i>alliances:' . '</i><br><dl class=\'assets\'><dd>';
							foreach ($alliancestandingsalliance as $temp)
							{	
								// alternate listmode
								if ($listmode == "list-odd")
									$listmode = "list-even";
								else
									$listmode = "list-odd";
								
								$page .= '<div class=\'' . $listmode . '\'>' . $temp['toName'] . " - " . $temp['standing'] . '</div>';
							}
							$page .= '</dd></dl>';
						}
						// alliances to corporation
						if ( count($alliancestandingscorp) > 0 )
						{
							$page .= '<i>corporations:' . '</i><br><dl class=\'assets\'><dd>';
							foreach ($alliancestandingscorp as $temp)
							{	
								// alternate listmode
								if ($listmode == "list-odd")
									$listmode = "list-even";
								else
									$listmode = "list-odd";
								
								$page .= '<div class=\'' . $listmode . '\'>' . $temp['toName'] . " - " . $temp['standing'] . '</div>';
							}
							$page .= '</dd></dl>';
						}
					}
					// Corporation
					if ( (count($corporationstandingsalliance) > 0) || (count($corporationstandingscorp) > 0) ||
						 (count($corporationstandingschar) > 0) )
					{
						// corporation to alliances
						$page .= '<b>Corporation Standings:' . '</b><br>';
						if ( count($corporationstandingsalliance) > 0 )
						{
							$page .= '<i>alliances:' . '</i><br><dl class=\'assets\'><dd>';
							foreach ($corporationstandingsalliance as $temp)
							{	
								// alternate listmode
								if ($listmode == "list-odd")
									$listmode = "list-even";
								else
									$listmode = "list-odd";
								
								$page .= '<div class=\'' . $listmode . '\'>' . $temp['toName'] . " - " . $temp['standing'] . '</div>';
							}
							$page .= '</dd></dl>';
						}
						// corporation to corporations
						if ( count($corporationstandingscorp) > 0 )
						{
							$page .= '<i>corporations:' . '</i><br><dl class=\'assets\'><dd>';
							foreach ($corporationstandingscorp as $temp)
							{	
								// alternate listmode
								if ($listmode == "list-odd")
									$listmode = "list-even";
								else
									$listmode = "list-odd";
								
								$page .= '<div class=\'' . $listmode . '\'>' . $temp['toName'] . " - " . $temp['standing'] . '</div>';
							}
							$page .= '</dd></dl>';
						}
						// corporation to characters
						if ( count($corporationstandingschar) > 0 )
						{
							$page .= '<i>characters:' . '</i><br><dl class=\'assets\'><dd>';
							foreach ($corporationstandingschar as $temp)
							{	
								// alternate listmode
								if ($listmode == "list-odd")
									$listmode = "list-even";
								else
									$listmode = "list-odd";
								
								$page .= '<div class=\'' . $listmode . '\'>' . $temp['toName'] . " - " . $temp['standing'] . '</div>';
							}
							$page .= '</dd></dl>';
						}
					}
					$page .= '</div>';
				} else {
					$page .= '<div class="header">
						<i>corporation has no standings set</i><div class="right-element">(trawled: ' . $currenttime . ')</div></div>';
				}
				// END OF CORP STANDINGS
				
			// end of page
			$page .= '</div>';
			}
		}
		$charactercounter = $currentcharactercounter;
		$page .= '</div>';
	}
	
	//
	//	Analysis Page
	//
	$page .= '<div id="accanalysis-page" class="active-page">';
	
	// Player Donations
	if (isset($playerdonation))
	{
		// check if something would be printed
		$printcheck = false;
		foreach($playerdonation as $firstplayer=>$secondarray)
		{
			foreach($secondarray as $secondplayer=>$val)
			{
				if ( (($val >= 10000000) || ($val <= -10000000)) && (($firstplayer != "<i>n/a</i>") && ($secondplayer != "<i>n/a</i>")) )
					$printcheck = true;
			}
		}
		
		if ($printcheck)
		{
			$page .= '<br/><b>Player Donations:</b><br/>';
				  
			foreach($playerdonation as $firstplayer=>$secondarray)
			{
				foreach($secondarray as $secondplayer=>$val)
				{
					if ( (($val >= 10000000) || ($val <= -10000000)) && (($firstplayer != "<i>n/a</i>") && ($secondplayer != "<i>n/a</i>")) )
						$page .= $firstplayer . ' &rarr; ' . $secondplayer . ': ' . number_format($val,2) . ' isk<br/>';
				}
			}
		}
	}
	
	// Corp Donations
	if (isset($corpdonation))
	{
		// check if something would be printed
		$printcheck = false;
		foreach($corpdonation as $firstplayer=>$secondarray)
		{
			foreach($secondarray as $secondplayer=>$val)
			{
				if ( (($val >= 10000000) || ($val <= -10000000)) && (($firstplayer != "<i>n/a</i>") && ($secondplayer != "<i>n/a</i>")) )
					$printcheck = true;
			}
		}
		
		if ($printcheck)
		{
			$page .= '<br/><b>Corporation Donations:</b><br/>';
				  
			foreach($corpdonation as $firstplayer=>$secondarray)
			{
				foreach($secondarray as $secondplayer=>$val)
				{
					if ( (($val >= 10000000) || ($val <= -10000000)) && (($firstplayer != "<i>n/a</i>") && ($secondplayer != "<i>n/a</i>")) )
						$page .= $firstplayer . ' &rarr; ' . $secondplayer . ': ' . number_format($val,2) . ' isk<br/>';
				}
			}
		}
	}
	
	// Player Trades
	if (isset($playertrades))
	{
		$page .= '<br/><b>Player Trades:</b><br/>';
		foreach($playertrades as $firstplayer=>$secondarray)
		{
			foreach($secondarray as $secondplayer=>$val)
			{
				$page .= $firstplayer . ' &rarr; '.$secondplayer . ': ' . $val . ' trades<br/>';
			}
		}
	}
	
	// Corp Trades - shouldn't ever happen
	if (isset($corptrades))
	{
		$page .= '<br/><b>Corporation Trades:</b><br/>';
		foreach($corptrades as $firstplayer=>$secondarray)
		{
			foreach($secondarray as $secondplayer=>$val)
			{
				$page .= $firstplayer . ' &rarr; '.$secondplayer . ': ' . $val . ' trades<br/>';
			}
		}
	}
	
	// ISK transfers > 10mil
	if (isset($othertransfers))
	{
		// check if something would be printed
		$printcheck = false;
		foreach($othertransfers as $firstplayer=>$secondarray)
		{
			foreach($secondarray as $secondplayer=>$val)
			{
				if ( (($val >= 10000000) || ($val <= -10000000)) && (($firstplayer != "<i>n/a</i>") && ($secondplayer != "<i>n/a</i>")) )
					$printcheck = true;
			}
		}
		
		if ($printcheck)
		{
			$page .= '<br/><b>All other player isk transfers above 10,000,000.00 isk:</b><br/>';
			foreach($othertransfers as $firstplayer=>$secondarray)
			{
				foreach($secondarray as $secondplayer=>$val)
				{
					if ( (($val >= 10000000) || ($val <= -10000000)) && (($firstplayer != "<i>n/a</i>") && ($secondplayer != "<i>n/a</i>")) )
						$page .= $firstplayer . ' &rarr; ' . $secondplayer . ': ' . number_format($val,2) . ' isk<br/>';
				}
			}
		}
	}
	
	// Corp ISK transfers > 10mil
	if (isset($corpothertransfers))
	{
		// check if something would be printed
		$printcheck = false;
		foreach($corpothertransfers as $firstplayer=>$secondarray)
		{
			foreach($secondarray as $secondplayer=>$val)
			{
				if ( (($val >= 10000000) || ($val <= -10000000)) && (($firstplayer != "<i>n/a</i>") && ($secondplayer != "<i>n/a</i>")) )
					$printcheck = true;
			}
		}
		
		if ($printcheck)
		{
			$page .= '<br/><b>All other corporation isk transfers above 10,000,000.00 isk:</b><br/>';
			foreach($corpothertransfers as $firstplayer=>$secondarray)
			{
				foreach($secondarray as $secondplayer=>$val)
				{
					if ( (($val >= 10000000) || ($val <= -10000000)) && (($firstplayer != "<i>n/a</i>") && ($secondplayer != "<i>n/a</i>")) )
						$page .= $firstplayer . ' &rarr; ' . $secondplayer . ': ' . number_format($val,2) . ' isk<br/>';
				}
			}
		}
	}
	
	// $ConquerableAssets
	if (isset($ConquerableAssets))
	{
		$page .= '<br/><b>Player Assets within Conquerable Stations:</b><br/>';
		foreach($ConquerableAssets as $conqplayer=>$secondarray)
		{
			$page .= '<b>' . $conqplayer . ':</b><br/>';
			foreach($secondarray as $conqstation=>$val)
			{
				$page.= $conqstation . ': ' . number_format($val,0) . ' items<br/>';
			}
		}
	}
	
	// $CorpConquerableAssets
	if (isset($CorpConquerableAssets))
	{
		$page .= '<br/><b>Corporation Assets within Conquerable Stations:</b><br/>';
		foreach($CorpConquerableAssets as $conqplayer=>$secondarray)
		{
			$page .= '<b>' . $conqplayer . ':</b><br/>';
			foreach($secondarray as $conqstation=>$val)
			{
				$page.= $conqstation . ': ' . number_format($val,0) . ' items<br/>';
			}
		}
	}
	
	$page .= '</div>';
	// End of Analysis Page
		
	// End of HTML
	$page .= '</div>';
	
	// add footer and print page
	$page .= $footer;
	print $page;
} else {
	echo "you are not logged into forum";
}
?>